var DKI;
if (!DKI) {
	DKI = {};
}

DKI.ContentPage = (function () {
	//Used to determine if content is being served via http or https.  If not, 
	//we assume being served directly from filesystem, or wrapped in a native 
	//mobile application
	var contentAPI;
	var isOnWeb = function () {
		var currentLocation = window.location.href;
		var webBasedSearch = /http:\/\/|https:\/\//i;

		return webBasedSearch.test(currentLocation);
	};
	var stage = $("#contentFrame");
	var stageOverflow = stage.css("overflow-y");
	var playerOnWeb = isOnWeb();
	//Holds internal functions for handling/manipulating media functions
	var mediaFunctions = function () {
		var flashTimeout = 0;
		var nativeAudio = false;
		var nativeVideo = false;
		var hasFlash = false;
		var solution = dkiUA.iOS || 
			(dkiUA.android && dkiUA.androidVersion >= 3) || 
			(dkiUA.ie && dkiUA.ieVersion >= 10) ? "html,flash" : "flash,html";
		var createVideoPlayerMarkup = function (id, hideControls) {
			var videoMarkup = "" +
			"<div id=\"" + id + "_container\" class=\"jp-video\">" +				
				"<div class=\"jp-type-single\">" +
					"<div id=\"" + id + "_player\" class=\"jp-video-player\" tabindex=\"0\"></div>" +
					"<div class=\"jp-video-play\">" +
						"<a class=\"jp-video-play-icon\" tabindex=\"0\">play</a>" +						
					"</div>" +					
					"<div class=\"jp-gui\">";
			if (!hideControls) {
				videoMarkup += "" +
						"<div class=\"jp-interface\">" +
							"<div class=\"jp-progress\">" +
								"<div class=\"jp-seek-bar\">" +
									"<div class=\"jp-play-bar\"></div>" +
								"</div>" +
							"</div>" +
							"<div class=\"jp-current-time\"></div>" +
							"<div class=\"jp-duration\"></div>" +
							"<div class=\"jp-controls-holder\">" +
								"<ul class=\"jp-controls\">" +
									"<li><a class=\"jp-play\" tabindex=\"0\" role=\"button\">play</a></li>" +
									"<li><a class=\"jp-pause\" tabindex=\"0\" role=\"button\">pause</a></li>" +
									"<li><a class=\"jp-full-screen\" tabindex=\"0\" role=\"button\">full</a></li>" +
									"<li><a class=\"jp-restore-screen\" tabindex=\"0\" role=\"button\">restore</a></li>" +
									"<li><a class=\"jp-mute\" tabindex=\"0\" role=\"button\">mute</a></li>" +
									"<li><a class=\"jp-unmute\" tabindex=\"0\" role=\"button\">unmute</a></li>" +
								"</ul>" +
								"<div class=\"jp-volume-bar\">" +
									"<div class=\"jp-volume-bar-value\"></div>" +
								"</div>" +
							"</div>" +
						"</div>" +
					"</div>" +
				"</div>";
			}
			videoMarkup += "</div>";
			return videoMarkup;
		};
		var createAudioPlayerMarkup = function (id, type, hideControls) {
			var returnString = "<div id=\"" + id + "\" class=\"jp-" + type;
			if (hideControls) {
				returnString += " hideControls";
			}
			returnString += "\">" +
			"<div class=\"jp-type-single\">";
				returnString += "<div class=\"jp-gui jp-interface\">" +
					"<div class=\"jp-controls-holder\">" +
						"<ul class=\"jp-controls\">" +
							"<li><a class=\"jp-play\" tabindex=\"0\" role=\"button\">play</a></li>" +
							"<li><a class=\"jp-pause\" tabindex=\"0\" role=\"button\">pause</a></li>";
				if (type !== "basic") {
					returnString += "<li><a class=\"jp-mute\" tabindex=\"0\" role=\"button\">mute</a></li>" +
								"<li><a class=\"jp-unmute\" tabindex=\"0\" role=\"button\">unmute</a></li>";
				}
				returnString += "</ul>" +
						"</div>" +
						"<div class=\"jp-progress\">" +
							"<div class=\"jp-seek-bar\">" +
								"<div class=\"jp-play-bar\"></div>" +
							"</div>" +
						"</div>" +
					"</div>" +
					"<div class=\"jp-no-solution\">" +
						"<span>No workee</span>" +
					"</div>" +
				"</div>";
			returnString += "</div>";
			return returnString;
		};
		var resolveMediaURL = function (pageInstance, URL) {
			var absRegEx = /^https?:\/\/|^\//;
			if (!absRegEx.test(URL)) {
				URL = pageInstance.rootURL + URL;
			}

			return URL;
		};
		//Used to determine if the native audio tag is supported for .mp3 files
		var testAudio = function () {
			var audio = document.createElement("audio");
			//Blackberry 6 'supports' audio, but performance is lousy enough
			//to go without
			if(dkiUA.blackberry && dkiUA.blackberryVersion < 7){
				return false;
			}
			//Audio in native apps is dicey on Android
			if(dkiUA.android && !playerOnWeb){
				return false;
			}
			//audio performs terrible on webOS
			if (dkiUA.webOS) {
				return false;
			}
			if (audio.canPlayType && audio.canPlayType('audio/mpeg') != "") {
				return true;
			}

			return false;
		};

		//Used to determine if the native video tag is supported for MP4.
		var testVideo = function () {
			var video = document.createElement("video");
			if(dkiUA.blackberry && dkiUA.blackberryVersion < 7){
				return false;
			}
			if(dkiUA.android && !playerOnWeb){
				return false;
			}
			if (video.canPlayType && video.canPlayType('video/mp4') != "") {
				return true;
			}

			return false;
		};

		var jplayerFlashResetHandler = function (pageInstance, mediaElem) {
		};

		//Sets up handlers & replaces content for media elements based on current
		//device capabilities
		var handleMedia = function (pageInstance) {	
			var videos = $(".dki-video-content-element", pageInstance.pageContainer);
			var sounds = $("div[data-elementType='audio']", pageInstance.pageContainer);	
			pageInstance.mediaCount = videos.length + sounds.length;
			pageInstance.readyMediaCount = 0;
			handleVideo(videos, pageInstance);
			handleAudio(sounds, pageInstance);
			//Fire ready event
			if (pageInstance.mediaCount === 0) {
				pageInstance.fireReady();
			}
		};

		var mediaIsReady = function (pageInstance) {
			if (pageInstance.mediaCount === pageInstance.readyMediaCount) {
				pageInstance.fireReady();
			}
		};

		//Sets up handlers and replaces content for audio elements
		var handleAudio = function (sounds, pageInstance) {
			sounds.each(function () {
				var extension = $(this).data("extension").toLowerCase();
				var media = {};
				var controls;
				var hideControls = !$(this).data("controls");
				var autoplay = $(this).data("autoplay");
				var loop = $(this).data("loop");
				var type = $(this).data("playerskin") ? "basic" : "audio";
				var renderHidden = $(this).parent().parent().data("renderhidden");
				var readyFunction = function (e) {
					var mediaElem = $(this);
					//If a flash solution is used, we need to handle the 'flashreset' event thrown 
					//after player is hidden during reset and shown again.  Ultimately, this is to ensure any hidden
					//auto-play content is played on 'show' after a page reset, or going forward then back again.
					if (e.jPlayer.flash.used) {
						//Reset event is shown, change ready state
						//mediaFunctions.jplayerFlashResetHandler(pageInstance, mediaElem);
						$(pageInstance.pageContainer).on(DKI.ContentPage.events.reset, function (e) {
							mediaElem.on($.jPlayer.event.flashreset, function (e) {																
								//mediaFunctions.play will attempt to delay & bind to the ready event
								//if the player isn't currently ready.  Fire to ensure the bound play function 
								//is executed
								mediaElem.trigger($.jPlayer.event.ready);
								mediaElem.unbind(e);
							});
						});
					}
					mediaElem.jPlayer("setMedia", media);
					pageInstance.readyMediaCount += 1;
					mediaIsReady(pageInstance);
					mediaElem.unbind(e);
				};
				//case 26637: jPlayer doesnt want to play mp4's. 
				//http://groups.google.com/group/jplayer/browse_thread/thread/72210fec0d912233/856cf89cdfde56d1
				if(extension.toLowerCase() == "mp4"){
					extension = "m4a";
				}
				media[extension] = mediaFunctions.resolveMediaURL(pageInstance, $(this).data("src"));
				if (!nativeAudio && !hasFlash) {
					var mediaLink = $(".dki-media-link", this);
					if (mediaLink.parent().hasClass("dki-audio-basic")) {
						mediaLink.parent().removeClass("dki-audio-basic");
						mediaLink.addClass("dki-audio-basic");
					}
				}	
				else {
					//Create jPlayer skin markup
					controls = createAudioPlayerMarkup(this.id + "_controls", type, hideControls);
					$(this).after(controls);
					$(this).jPlayer({
						swfPath: settings.swfPath,
						cssSelectorAncestor: "#" + this.id + "_controls",
						ready: readyFunction,
						supplied: extension,
						loop: loop,
						solution: solution,
						preload: "auto",
						autohide: {
							restored: $(this).data("controls") === "true" ? true : false
						},
						muted: contentAPI.getAudioStatus() ? false : true,
						volume: 1
					});
					$(this).data("renderhidden", renderHidden);
				}
				pageInstance.mediaPlayers[this.id] = $(this);
				actionFunctions.registerMediaPlayer($(this), pageInstance);
				if (autoplay) {
					pageInstance.autoPlayMedia.push($(this));
				}
			});
		};

		//Sets up handlers and replaces content for video elements
		var handleVideo = function (videos, pageInstance) {
			var mediaFunction;
			if (nativeVideo || (hasFlash && playerOnWeb)) {
				mediaFunction = function () {
					var extension = $(this).data("extension").toLowerCase();
					var media = {};
					var hideControls = !$(this).data("controls");
					var controls;
					var loop = $(this).data("loop");
					var autoplay = $(this).data("autoplay");
					var renderHidden = $(this).parent().parent().data("renderhidden");
					var wrapper = $(this).parent().parent(); 
					var fullScreen = $(this).data("allowfullscreen");
					var player;
					var autoHide = {
						restored: true,
						full: true
					};
					var readyFunction = function (e) {
						var mediaElem = $(this);
						if (!fullScreen) {
							//Ensure fullScreen button isn't shown.
							$(this).data().jPlayer.status.noFullScreen = true;
						}
						//If a flash solution is used, we need to handle the 'flashreset' event thrown 
						//after player is hidden during reset and shown again.  Ultimately, this is to ensure any hidden
						//auto-play content is played on 'show' after a page reset, or going forward then back again.
						if (e.jPlayer.flash.used) {
							//Reset event is shown, change ready state
							//mediaFunctions.jplayerFlashResetHandler(pageInstance, mediaElem);
							$(pageInstance.pageContainer).on(DKI.ContentPage.events.reset, function (e) {								
								mediaElem.on($.jPlayer.event.flashreset, function (e) {																
									//mediaFunctions.play will attempt to delay & bind to the ready event
									//if the player isn't currently ready.  Fire to ensure the bound play function 
									//is executed
									mediaElem.trigger($.jPlayer.event.ready);
									mediaElem.unbind(e);
								});
							});
						}
						$(this).jPlayer("setMedia", media);
						$(this).bind($.jPlayer.event.pause, function (e) {
							$(".jp-video-play", this.parentNode).css("display", "");
						});
						$(this).bind($.jPlayer.event.play, function (e) {
							$(".jp-video-play", this.parentNode).css("display", "none");
						});
						$(this).bind($.jPlayer.event.click, function (e) {
							if (e.jPlayer.status.paused) {
								$(this).jPlayer("play");
							}
							else {
								$(this).jPlayer("pause");
							}
						});
						pageInstance.readyMediaCount += 1;
						mediaIsReady(pageInstance);
						$(this).unbind(e);
					};
					var resizeFunction = function (e) {
						var playerObj = $(this)
						var fullScreen = playerObj.jPlayer("option", "fullScreen");
						if (fullScreen) {
							onFullScreen(playerObj);
						}
						else {
							onRestoreScreen(playerObj);
						}
					};
					var onFullScreen = function (jplayer) {
						var parentObj = jplayer.parents(".dki-authoring-element");
						parentObj.css({top: "0px", left: "0px", height: stage.css("height"), width: stage.css("width"), zIndex: "100000"});
						stage.css("overflow-y", "hidden");
						$(".dkiContentFrame.current").css("overflow-y", "hidden");
					};
					var onRestoreScreen = function (jplayer) {											
						var parentObj = jplayer.parents(".dki-authoring-element");						
						var top = parentObj.data("y") + "px";
						var left = parentObj.data("x") + "px";
						var height = parentObj.data("height") + "px";
						var width = parentObj.data("width") + "px";
						var zIndex = parentObj.data("elementno");
						parentObj.css({top: top, left: left, height: height, width: width, zIndex: zIndex});						
						stage.css("overflow-y", stageOverflow);
						$(".dkiContentFrame.current").css("oveflow-y", stageOverflow);
					};
					//Firefox on OSX has issues with auto-hiding controls, doesn't seem to register mouse-over to reshow.
					if (dkiUA.firefox && !dkiUA.windows) {
						autoHide = {
							restored: false,
							full: false
						};
					}
					//case 26637: jPlayer doesnt want to play mp4's. 
					//http://groups.google.com/group/jplayer/browse_thread/thread/72210fec0d912233/856cf89cdfde56d1
					if(extension.toLowerCase() == "mp4" || extension.toLowerCase() == "mov"){
						extension = "m4v";
					}
					media[extension] = mediaFunctions.resolveMediaURL(pageInstance, $(this).data("src"));
					controls = createVideoPlayerMarkup(this.id, hideControls);
					$(this).html(controls);
					player = $("#" + this.id + "_player");
					if (!fullScreen) {
						$(this).addClass("no-fullscreen");
					}
					player.jPlayer({
						swfPath: settings.swfPath,
						cssSelectorAncestor: "#" + this.id + "_container",
						ready: readyFunction,
						resize: resizeFunction,
						supplied: extension,
						loop: loop,
						preload: "auto",
						solution: solution,
						nativeVideoControls: {
							ipad: /ipad/,
							iphone: /iphone/,
							ipod: /ipod/,
							android_pad: /Android/i,
							android_phone: /Android/i,
							blackberry: /blackberry/,
							windows_ce: /windows ce/,
							webos: /webos/
						},
						size: {
							width: $(this).data("width") + "px",
							height: $(this).data("height") + "px"
						},
						sizeFull: {
							height: stage.css("height")
						},
						autohide: autoHide,
						muted: contentAPI.getAudioStatus() ? false : true,
						volume: 1,
						//specifying this as apparently fullscreen is disabled in IE6 by default. 
						noFullScreen: {
						}
					});
					player.data("renderhidden", renderHidden);
					pageInstance.mediaPlayers[this.id] = player;
					actionFunctions.registerMediaPlayer(player, pageInstance);
					if (autoplay) {
						pageInstance.autoPlayMedia.push(player);
					}
					player.bind($.jPlayer.event.ended, function(event){
						$(".jp-restore-screen", $(this).parents(".dki-authoring-element")).click();						
					});
				};
			}
			else {
				mediaFunction = function () {
					//Because this function is called within the jQuery 'each' method, 
					//'this' is the current element in the collection
					var mediaLink = $(".dki-media-link", this);
					mediaLink.prop("href", $(this).data("src"));
					return mediaLink;
				};
			}
			videos.each(mediaFunction);
		};

		//Determines if the current device supports autoplay
		var canAutoplay = function (){	
			if(dkiUA.iOS){
				return false;
			}
			return true;
		};

		var play = function (mediaElement, pageInstance) {
			var bindFunction;
			if (typeof(mediaElement) === "string") {
				mediaElement = pageInstance.mediaPlayers[mediaElement];
			}	
			//try playing it
			mediaElement.jPlayer("play");
			//bind to ready in case it cant be played yet.
			bindFunction = function (e) {												
				mediaElement.jPlayer("play");
				mediaElement.unbind(e);
			};
			$(mediaElement).bind($.jPlayer.event.ready, bindFunction);
		};
		
		nativeAudio = testAudio();
		nativeVideo = testVideo();
		hasFlash = swfobject.hasFlashPlayerVersion("10.1.0");

		return {
			handleMedia: handleMedia,
			resolveMediaURL: resolveMediaURL,
			play: play
		};

	}();

	var contentFunctions = {
		setAudio: function (audio, pageInstance) {
			var name;
			if (audio === true) {
				for (name in pageInstance.mediaPlayers) {
					pageInstance.mediaPlayers[name].jPlayer("unmute");
				}
				this.resumeAll(pageInstance);
			}
			else {
				for (name in pageInstance.mediaPlayers) {
					pageInstance.mediaPlayers[name].jPlayer("mute");
				}
				this.pauseAll(pageInstance);
			}
		},
		pauseAll: function (pageInstance){
			var name;
			pageInstance.autoPaused = [];
			for (name in pageInstance.mediaPlayers) {
				var id = name.replace("content_", "");
				if ($("#" + id + "_wrapper").data("dontpause") != true) {
					if (!this.isPaused(pageInstance.mediaPlayers[name])) {
						pageInstance.mediaPlayers[name].jPlayer("pause");
						pageInstance.autoPaused.push(name);
					}
				}
			}
		},
		resumeAll: function (pageInstance) {
			var name;
			for (var i = 0; i < pageInstance.autoPaused.length; i += 1) {
				name = pageInstance.autoPaused[i];
				pageInstance.mediaPlayers[name].jPlayer("play");
			}
			pageInstance.autoPaused = [];
		},
		startAutoPlay: function (pageInstance) {
			var autoPlayCount = pageInstance.autoPlayMedia.length;
			for (var i = 0; i < autoPlayCount; i += 1) {
				if (!pageInstance.autoPlayMedia[i].data("renderhidden")) {
					mediaFunctions.play(pageInstance.autoPlayMedia[i]);
				}
			}
		},
		stopAll: function (pageInstance) {
			var name;	
			var mediaPlayers = pageInstance.mediaPlayers;
			for (name in mediaPlayers) {
				if (mediaPlayers.hasOwnProperty(name)) {
					if (mediaPlayers[name].data().jPlayer.status.paused) {
						mediaPlayers[name].jPlayer("playHead", 0);
					}
					else {						
						mediaPlayers[name].jPlayer("stop");
					}
					mediaPlayers[name].jPlayer("option", "fullScreen", false);
				}
			}
		},
		isPaused: function (mediaElement) {
			return mediaElement.data().jPlayer.status.paused;
		}
	};
	//holds all the functions that execute actions on things. Dependencies: assetURL, mediaPlayers, contentAPI
	var actionFunctions = {		
		init: function(actions, pageInstance, clickEvent){
			pageInstance.actions = actions;
			//Remove any old delegates on the pageContainer element
			$(pageInstance.pageContainer).undelegate();
			this.clearPageTimeouts(pageInstance);
			var self = this;
			var mouseHandler = function(e){				
				self.onMouseEvent.call(self, e.type, this, pageInstance);
			};
			$(pageInstance.pageContainer).delegate(".dki-authoring-element", clickEvent, function(e){								
				self.onMouseEvent.call(self, "click", this, pageInstance);				
			});
			$(pageInstance.pageContainer).delegate(".dki-authoring-element", "contextmenu", function(e){							
				var actions = self.onMouseEvent.call(self, "rightClick", this, pageInstance);
				if(actions.length > 0){
					return false;
				}
			});
			$(pageInstance.pageContainer).delegate(".dki-authoring-element", "dblclick", mouseHandler);
			$(pageInstance.pageContainer).delegate(".dki-authoring-element", "mouseenter", mouseHandler);
			$(pageInstance.pageContainer).delegate(".dki-authoring-element", "mouseleave", mouseHandler);
			$(pageInstance.pageContainer).delegate(".dki-authoring-element", DKI.ContentPage.events.shown, function(){
				self.onDisplayEvent.call(self, "show", this, pageInstance);
			});
			$(pageInstance.pageContainer).delegate(".dki-authoring-element", DKI.ContentPage.events.hidden, function(){
				self.onDisplayEvent.call(self, "hide", this, pageInstance);
			});
					
			this.setupLinkedElements(actions, pageInstance.pageContainer, clickEvent);
			this.setupRollovers(pageInstance.pageContainer);
			pageInstance.mediaTimeUpdates = {};
		},
		startTimeouts: function(pageInstance) {
			//start timeouts for page			
			for(var i = 0; i < pageInstance.actions.length; i++){
				if(pageInstance.actions[i].pageId){
					this.startPageTimer(pageInstance.actions[i], pageInstance);
				}
			}
		},
		registerMediaPlayer: function(player, pageInstance){			
			var self = this;
			$(player).bind($.jPlayer.event.play, function(event){
				var elementId = this.id.replace("content_", "").replace("_player", "");
				self.onMediaPlay(elementId, pageInstance);
				var time = event.jPlayer.status.currentTime * 1000;				
				if (time < 600) {
					self.onMediaStart(elementId, pageInstance);
				}
			});
			$(player).bind($.jPlayer.event.pause, function(event){
				var elementId = this.id.replace("content_", "").replace("_player", "");
				self.onMediaPause(elementId, pageInstance);
			});			
			$(player).bind($.jPlayer.event.ended, function(event){
				var elementId = this.id.replace("content_", "").replace("_player", "");
				self.onMediaEnd(elementId, pageInstance);
			});
			$(player).bind($.jPlayer.event.volumechange, function(event){				
				var elementId = this.id.replace("content_", "").replace("_player", "");
				if(event.jPlayer.options.muted){
					self.onMediaVolumeChange(elementId, "mute", pageInstance);
				}
				else {
					self.onMediaVolumeChange(elementId, "unmute", pageInstance);
				}
			});
			$(player).bind($.jPlayer.event.timeupdate, function(event){				
				var elementId = this.id.replace("content_", "").replace("_player", "");
				if(!pageInstance.mediaTimeUpdates[elementId]){
					pageInstance.mediaTimeUpdates[elementId] = 0;
				}
				var time = event.jPlayer.status.currentTime * 1000;			
				if(time > 0 && (time - pageInstance.mediaTimeUpdates[elementId]) > 200){
					pageInstance.mediaTimeUpdates[elementId] = time;
					self.onTimeUpdate(time, elementId, pageInstance);					
				}
			});
		},
		reset: function(pageInstance){
			this.clearPageTimeouts(pageInstance);
			for(var i = 0; i < pageInstance.actions.length; i++){				
				pageInstance.actions[i].firedOnce = false;				
			}
			pageInstance.mediaTimeUpdates = {};
		},	
		startPageTimer: function (action, pageInstance){		
			var self = this;
			var handler = function(){														
				self.actionHandlers[action.type](action, pageInstance);
			};		
			pageInstance.pageTimeouts.push(setTimeout(handler, action.time));
		},
		clearPageTimeouts: function(pageInstance){
			if (pageInstance.pageTimeouts) {
				for(var i = 0; i < pageInstance.pageTimeouts.length; i++){
					clearTimeout(pageInstance.pageTimeouts[i]);
				}
			}
			pageInstance.pageTimeouts = [];
		},
		onMouseEvent: function(type, target, pageInstance){			
			var actions = this.getActionsForEvent(type, $(target).data("id"), pageInstance);
			for(var i = 0; i < actions.length; i++){				
				this.actionHandlers[actions[i].type](actions[i], pageInstance);
			}
			return actions;
		},
		onDisplayEvent: function(type, target, pageInstance){
			var actions = this.getActionsForEvent(type, $(target).data("id"), pageInstance);
			for(var i = 0; i < actions.length; i++){				
				this.actionHandlers[actions[i].type](actions[i], pageInstance);
			}
		},
		onTimeUpdate: function(time, elementId, pageInstance){				
			var actions = this.getActionForMediaEvent("time", elementId, pageInstance, time);		
			for(var i = 0; i < actions.length; i++){						
				this.actionHandlers[actions[i].type](actions[i], pageInstance);	
				actions[i].firedOnce = true;			
			}
		},
		onMediaStart: function(elementId, pageInstance){										
			var actions = this.getActionForMediaEvent("start", elementId, pageInstance);			
			for(var i = 0; i < actions.length; i++){						
				this.actionHandlers[actions[i].type](actions[i], pageInstance);
			}
		},
		onMediaEnd: function(elementId, pageInstance){
			for(var i = 0; i < pageInstance.actions.length; i++){
				if(pageInstance.actions[i].elementId == elementId){
					pageInstance.actions[i].firedOnce = false;
				}
			}			
			var actions = this.getActionForMediaEvent("end", elementId, pageInstance);			
			for(var i = 0; i < actions.length; i++){						
				this.actionHandlers[actions[i].type](actions[i], pageInstance);
			}
		},
		onMediaPlay: function(elementId, pageInstance){		
			var actions = this.getActionForMediaEvent("play", elementId, pageInstance);			
			for(var i = 0; i < actions.length; i++){						
				this.actionHandlers[actions[i].type](actions[i], pageInstance);
			}
		},
		onMediaPause: function(elementId, pageInstance){		
			var actions = this.getActionForMediaEvent("pause", elementId, pageInstance);			
			for(var i = 0; i < actions.length; i++){						
				this.actionHandlers[actions[i].type](actions[i], pageInstance);
			}
		},
		onMediaVolumeChange: function(elementId, trigger, pageInstance){			
			var actions = this.getActionForMediaEvent(trigger, elementId, pageInstance);			
			for(var i = 0; i < actions.length; i++){						
				this.actionHandlers[actions[i].type](actions[i], pageInstance);
			}
		},
		//utility/helper stuff		
		getActionsForEvent: function(trigger, elementId, pageInstance){
			var actions = [];
			for(var i = 0; i < pageInstance.actions.length; i++){
				if(pageInstance.actions[i].trigger.toLowerCase() == trigger.toLowerCase() && pageInstance.actions[i].elementId == elementId){
					actions.push(pageInstance.actions[i]);
				}
			}
			return actions;
		},
		getActionForMediaEvent: function(trigger, elementId, pageInstance, time){			
			if(!time) time = 0;
			var actions = [];
			for(var i = 0; i < pageInstance.actions.length; i++){
				if(pageInstance.actions[i].trigger == trigger && 
					pageInstance.actions[i].elementId == elementId &&
					!pageInstance.actions[i].firedOnce &&
					pageInstance.actions[i].time <= (time + 250)) {						
						actions.push(pageInstance.actions[i]);
				}
			}
			return actions;
		},
		//necessary data-attributes on target elements
		setupLinkedElements: function (actions, pageContainer, clickEvent){
			for(var i = 0; i < actions.length; i++){
				if(actions[i].elementId){
					$("#" + actions[i].elementId + "_wrapper", pageContainer).css({
						"cursor": "pointer"
					});
				}
				for (var j = 0; j < actions[i].targetElements.length; j++) {
					$("#" + actions[i].targetElements[j] + "_wrapper", pageContainer).addClass("dki-event-target");
				}
			}
			$("[data-actiontype=pagelink]", pageContainer).each(function(){
				$(this).css({
					"cursor": "pointer"
				});
				$(this).on(clickEvent, function(){
					if (contentAPI) {
						contentAPI.jumpToSubeo($(this).data("actiontargets"));
					}
				});	
			});	
			$("[data-actiontype=imagemap]", pageContainer).each(function(){		
				var elementId = $(this).data("id");				
				var mapEl = document.getElementById(elementId + "_imagemap");
				if (mapEl) {
					for (var i = 0; i < mapEl.childNodes.length; i++) {
						processHrefTarget($(mapEl.childNodes[i]).data("hreftarget"), $(mapEl.childNodes[i]).data("hidetargetonload"));
					}
				}
			});
		},		
		setupRollovers: function (pageContainer){
			$(".dki-image-element", pageContainer).mouseover(function(){
				var id = $(this).data("id");		
				//image has a rollover		
				if($(this).data("rolloverassetid") && (!$(this).data("rolledover") || $(this).data("rolledover") == "false")){
					var showEffect = null;			
					var meta = $(this).data("meta");
					meta = meta.split(";");
					if(meta.length >= 1){				
						var showEffect = meta[0];
					}
					var rolledOver = $("#" + id + "_wrapper", pageContainer).data("rolledover");
					var hasCssReflect = $(this).hasClass('cssFX-slctr-Reflect');
					
					$('.dki-image-root-reflected',$("#" + id + "_wrapper")).attr('data-id',id)
					$('.dki-image-rollover-reflected',$("#" + id + "_wrapper")).attr('data-id',id)
					
					if(showEffect && showEffect !== "none" && (!rolledOver || rolledOver === "false")) {
						
						if(hasCssReflect){
							$('.dki-image-rollover-reflected',$("#" + id + "_wrapper")).show(showEffect,{},800)
							$('.dki-image-root-reflected',$("#" + id + "_wrapper")).hide(showEffect,{},800)
						}else{
							$("#content_" + id + "_rollover", pageContainer).show(showEffect, {}, 800);
							$("#content_" + id, pageContainer ).hide(showEffect, {}, 800);	
						}

						$("#" + id + "_wrapper", pageContainer).data("rolledover", "true");
					}
					else if(!rolledOver || rolledOver === "false"){
						
						if(hasCssReflect){
							$("#content_" + id + "_rollover", pageContainer).parent().show();
							$("#content_" + id, pageContainer ).parent().hide();
						}else{
							$("#content_" + id + "_rollover", pageContainer).show();
							$("#content_" + id, pageContainer ).hide();	
						}						
						
						$("#" + id + "_wrapper", pageContainer).data("rolledover", "true");
					}
					
					
				}	
			});

			$('.dki-image-rollover-reflected', pageContainer).mouseout(function(){
				rolloverOut($(this).data('id'),true)
			});
			
			$(".dki-image-rollover", pageContainer).mouseout(function(){
				rolloverOut($(this).data('id'),false)
			});
			
			function rolloverOut(id,hasCssReflect){
				
				var setToFalse = function(){
					$("#" + id + "_wrapper", pageContainer).data("rolledover", "false")
				};
				var hideEffect = null;
				var meta = $("#" + id + "_wrapper", pageContainer).data("meta");
				meta = meta.split(";");
				if(meta.length >= 2){
					var hideEffect = meta[1];
				};
					
				if(hideEffect && hideEffect !== "" && $("#" + id + "_wrapper", pageContainer).data("rolledover") == "true") {
					if(hideEffect !== "none"){
						
						if(hasCssReflect){
							$('.dki-image-root-reflected',$("#" + id + "_wrapper")).show(hideEffect, {}, 800, setToFalse);
							$('.dki-image-rollover-reflected',$("#" + id + "_wrapper")).hide(hideEffect, {}, 800, setToFalse)
						}else{
							$("#content_" + id, pageContainer).show(hideEffect, {}, 800, setToFalse);
							$("#content_" + id + "_rollover", pageContainer).hide(hideEffect, {}, 800, setToFalse)							
						};
					}else{
						if(hasCssReflect){
							$('.dki-image-root-reflected',$("#" + id + "_wrapper")).show();
							$('.dki-image-rollover-reflected',$("#" + id + "_wrapper")).hide();
						}else{
							$("#content_" + id, pageContainer).show();
							$("#content_" + id + "_rollover", pageContainer).hide();							
						}	
						setToFalse();
					}			
				}					
			}
			
		},
		
		//an object that holds all the action types as functions to call
		actionHandlers: {
			show: function(action, pageInstance){				
				var delay = 0;
				if(action.trigger != "time"){
					delay = action.time;
				}				
				var config = {
					type: action.type,
					effect: action.parameters.effect,
					targets: action.targetElements,
					delay: delay,
					action: action
				};
				if(action.parameters.effectOptions){
					config.effectOptions = action.parameters.effectOptions;
				}
				this.doDisplayAction(config, pageInstance);
			},
			hide: function(action, pageInstance){
				var delay = 0;
				if(action.trigger != "time"){
					delay = action.time;
				}
				var config = {
					type: action.type,
					effect: action.parameters.effect,
					targets: action.targetElements,
					delay: delay,
					action: action
				};
				if(action.parameters.effectOptions){
					config.effectOptions = action.parameters.effectOptions;
				}
				this.doDisplayAction(config, pageInstance);
			},
			toggle: function(action, pageInstance){								
				var showTargets = [];
				var hideTargets = [];
				if (action.targetElements) {
					for (var i = 0; i < action.targetElements.length; i++) {
						if ($("#" + action.targetElements[i] + "_wrapper").css("display") === "none") {
							showTargets.push(action.targetElements[i]);
						}
						else {
							hideTargets.push(action.targetElements[i]);
						}
					}
				}
				var delay = 0;
				if(action.trigger != "time"){
					delay = action.time;
				}				
				var showConfig = {
					type: "show",
					effect: action.parameters.showEffect,
					targets: showTargets,
					delay: delay,
					action: action
				};
				if(action.parameters.showEffectOptions){
					showConfig.effectOptions = action.parameters.showEffectOptions;
				}
				var hideConfig = {
					type: "hide",
					effect: action.parameters.hideEffect,
					targets: hideTargets,
					delay: delay,
					action: action
				};
				if(action.parameters.hideEffectOptions){
					hideConfig.effectOptions = action.parameters.hideEffectOptions;
				}
				this.doDisplayAction(showConfig, pageInstance);
				this.doDisplayAction(hideConfig, pageInstance);
			},			
			doDisplayAction: function(config, pageInstance){				
				var targets = this.getTargetSelector(config.targets);
				var targetsToHide = this.getTargetsToHide(config.action, pageInstance);
				var targetsToHideSelector = this.getTargetSelector(targetsToHide);
				var callback = function () {			
					$(targetsToHideSelector).hide();	
					var event = config.type === "show" ? DKI.ContentPage.events.shown : DKI.ContentPage.events.hidden;
					var contentID = "content_" + $(this).data("id");
					var content = $("#" + contentID);
					//Callback will be fired once for each element shown/hidden.  As it's a jQuery callback,
					//'this' will be the element being shown/hidden
					$(this).trigger(event, this);
					if (config.type === "show" && content.data("autoplay")) {
						mediaFunctions.play(contentID, pageInstance);						     
					}
					//gotta re-render the shape as some of the effects cause it to go white
					if($(this).data("type") == "shape" && dkiUA.ie){
						$("#" + $(this).data("id") + "_content_wrapper").empty();						
						shapeFunctions.renderShapes(this);
					}
				};
				if (targets !== "") {			
					var handler = function(){
						if (config.effect == "") {
							$(targets, pageInstance.pageContainer)[config.type](0, callback);
						}
						else {
							if (config.effectOptions) {
								if(config.effect == "blind" || config.effect == "clip"){
									if(config.effectOptions.direction){
										if(config.effectOptions.direction == "right" || config.effectOptions.direction == "left"){
											config.effectOptions.direction = "horizontal";
										}
										else if(config.effectOptions.direction == "up" || config.effectOptions.direction == "down"){
											config.effectOptions.direction = "vertical";
										}
									}
								}
								$(targets, pageInstance.pageContainer)[config.type](config.effect, config.effectOptions, callback);
							}
							else {
								$(targets, pageInstance.pageContainer)[config.type](config.effect, callback);
							}
						}
					};
					setTimeout(handler, config.delay);					
				}
				else if(targetsToHideSelector !== ""){
					$(targetsToHideSelector).hide();
				}
			},			
			applyEffect: function(action){
				var action = action;
				var time = 0;
				if(action.trigger != "time"){
					time = action.time;
				}
				var targets = this.getTargetSelector(action.targetElements);
				if (targets !== "") {
					var handler = function(){
						if (action.parameters && action.parameters.effectOptions) {
							$(targets).effect(action.parameters.effect, action.parameters.effectOptions);
						}
						else {
							$(targets).effect(action.parameters.effect);
						}
					};
					setTimeout(handler, time);
				}
			},
			http: function(action){
				if (action.parameters.url.indexOf("mailto:") > -1) {
					location.href = action.parameters.url;
				}
				else {
					if (action.parameters.target && action.parameters.target === "modal") {
						contentAPI.openModal(action.parameters.url);
					}
					else {
						var httpWindow = window.open(action.parameters.url, '_blank');
					}
				}
			},
			asset: function(action){
				if (action.parameters && action.parameters.target && action.parameters.target === "modal") {
					contentAPI.openModal(settings.assetURL + action.asset.filename);
				}
				else {
					var assetWindow = window.open(settings.assetURL + action.asset.filename, 'assetWindow');
				}				
			},
			api: function(action){
				contentAPI[action.parameters.method]();
			},
			playMedia: function(action, playerInstance){
				for (var i = 0; i < action.targetElements.length; i++) {
					var mediaEl = playerInstance.mediaPlayers["content_" + action.targetElements[i]];			
					if (action.parameters && typeof action.parameters.startTime !== 'undefined') {
						mediaEl.jPlayer("play", (action.parameters.startTime / 1000));
					}
					else{
						mediaEl.jPlayer("play");
					}
					if (action.parameters && typeof action.parameters.endTime !== 'undefined') {
						action.firedOnce = true;
						$(mediaEl).bind($.jPlayer.event.timeupdate, function(event){
							if (action.firedOnce) {
								var time = event.jPlayer.status.currentTime * 1000;
								if (time > action.parameters.endTime) {
									mediaEl.jPlayer("pause");
									action.firedOnce = false;
								}
							}		
						});
					}		
				}
			},
			replayMedia: function(action, playerInstance){
				for (var i = 0; i < action.targetElements.length; i++) {
					var mediaEl = playerInstance.mediaPlayers["content_" + action.targetElements[i]];			
					mediaEl.jPlayer("play", 0);
				}
			},
			pauseMedia: function(action, playerInstance){
				for (var i = 0; i < action.targetElements.length; i++) {					
					playerInstance.mediaPlayers["content_" + action.targetElements[i]].jPlayer("pause");
				}
			},
			toggleMedia: function(action, playerInstance){
				for (var i = 0; i < action.targetElements.length; i++) {
					var player = playerInstance.mediaPlayers["content_" + action.targetElements[i]];
					if(player.data().jPlayer.status.paused){
						player.jPlayer("play");
					}
					else{
						player.jPlayer("pause");
					}
				}
			},
			getTargetSelector: function(targetElements){
				var targetSelector = "";
				if (targetElements) {
					for (var i = 0; i < targetElements.length; i++) {
						targetSelector += "#" + targetElements[i] + "_wrapper,";
					}
				}
				if (targetSelector !== "") {
					targetSelector = targetSelector.substring(0, targetSelector.length - 1);
				}
				return targetSelector;
			},
			getTargetsToHide: function(action, pageInstance){
				var targetsToHide = [];
				if(action.parameters && action.parameters.hideOthers){
					for(var i = 0; i < pageInstance.actions.length; i++){											
						if(pageInstance.actions[i].type === "show" || pageInstance.actions[i].type === "toggle"){
							if (pageInstance.actions[i].id !== action.id && pageInstance.actions[i].targetElements) {
								for(var j = 0; j < pageInstance.actions[i].targetElements.length; j++){									
									if ($("#" + pageInstance.actions[i].targetElements[j] + "_wrapper").data("donthide") != true) {
										var partOfCurrentAction = false;
										for(var k = 0; k < action.targetElements.length; k++){
											if(action.targetElements[k] == pageInstance.actions[i].targetElements[j]){
												partOfCurrentAction = true;
											}
										}										
										if (!partOfCurrentAction) {
											targetsToHide.push(pageInstance.actions[i].targetElements[j]);
										}
									}
									
								}											
							}							
						}
					}
					$(".dki-imagemap-target").each(function(){
						if ($(this).data("donthide") != true) {
							var partOfCurrentAction = false;
							for(var k = 0; k < action.targetElements.length; k++){
								if(action.targetElements[k] == $(this).data("id")){
									partOfCurrentAction = true;
								}
							}										
							if (!partOfCurrentAction) {
								targetsToHide.push($(this).data("id"));
							}
						}
					});	
				};
				return targetsToHide;
			}
		}		
	};

	var shapeFunctions = {
		init : function (pageInstance) {
			if (this.canRenderShapes()) {
				try {
					this.loadShapes(pageInstance);		
				}
				catch(e){
					this.loadHtmlShapes(pageInstance);
				}
			}
			else {
				this.loadHtmlShapes(pageInstance);
			}
		},
		loadShapes: function (pageInstance) {
			var that = this;
			$(".dki-shape-element", pageInstance.pageContainer).each(function(){
				var display = this.style.display;
				$(this).css({
					opacity: 0,
					display: "block"
				});
				that.renderShapes(this);
			
				$(this).css({
					opacity: $(this).data("opacity"),
					display: display
				});
			});
		},
		loadHtmlShapes: function (pageInstance){
			$(".dki-shape-element", pageInstance.pageContainer).each(this.renderShapeHtml);
		},

		renderShapeHtml: function (){	
			var el = $(this);
			var shapetype = el.data("shapetype");
			if(shapetype != "rect" && shapetype != "hline" && shapetype != "vline" && shapetype != "circle" && shapetype != "ellipse"){
				return;
			}
			var id = el.data('id');	
			var titleString = "";
			if(el.data("title") != ""){
				titleString = "title='" + el.data("title") + "'";
			}
			var borderType = "solid";
			if(el.data("bordertype") == "."){
				borderType = "dotted";
			}
			else if(el.data("bordertype") == "-"){
				borderType = "dashed";
			}
			var styleString = "";
			if(shapetype == "rect"){		
				var width = el.data("width") - (parseInt(el.data("linethickness")) * 2);
				var height = el.data("height") - (parseInt(el.data("linethickness")) * 2);
				styleString += "width:" + width + "px;";
				styleString += "height:" + height + "px;";
				styleString += "border:" + el.data("linethickness") + "px " + borderType + " " + el.data("linecolour") + ";";
				styleString += "background-color:" + el.data("fillcolour") + ";";		
				if(el.data("roundedcorners") == true){			
					styleString += "-moz-border-radius: 15px; -webkit-border-radius: 15px;	border-radius: 15px;";
				}	
			}
			else if(shapetype == "hline"){
				styleString += "height:" + el.data("linethickness") + "px;";
				styleString += "width:" + el.data("width") + "px;";
				styleString += "border-top:" + el.data("linethickness") + "px " + borderType + " " + el.data("linecolour") + ";";
			}
			else if(shapetype == "vline"){
				styleString += "width:" + el.data("linethickness") + "px;";
				styleString += "height:" + el.data("height") + "px;";
				styleString += "border-left:" + el.data("linethickness") + "px " + borderType + " " + el.data("linecolour") + ";";	
			}
			else if(shapetype == "circle" || shapetype == "ellipse"){		
				var width = el.data("width") - (parseInt(el.data("linethickness")) * 2);
				var height = el.data("height") - (parseInt(el.data("linethickness")) * 2);
				styleString += "width:" + width + "px;";
				styleString += "height:" + height + "px;";
				styleString += "background-color:" + el.data("fillcolour") + ";";
				styleString += "border:" + el.data("linethickness") + "px " + borderType + " " + el.data("linecolour") + ";";
				var borderRadius = "";
				if(el.data("width") > el.data("height")){
					borderRadius = parseInt(el.data("width")) / 2 + "px";
				}
				else{
					borderRadius = parseInt(el.data("height")) / 2 + "px";
				}
				styleString += "-moz-border-radius: " + borderRadius + "; -webkit-border-radius:" + borderRadius + ";border-radius: " + borderRadius + ";";
			}
			var mouseOver = "";
			var mouseOut = "";
			if(el.data("rollover") == true){
				mouseOver += " onmouseover='"	
				mouseOver += 'this.style.backgroundColor = "' + el.data("rollovercolour") + '";';
				mouseOver += 'this.style.borderColor = "' + el.data("strokerollover") + '";';
				mouseOver += "' ";
				mouseOut += " onmouseout='"
				mouseOut += 'this.style.backgroundColor = "' + el.data("fillcolour") + '";';	
				mouseOut += 'this.style.borderColor = "' + el.data("linecolour") + '";';
				mouseOut += "' ";		
			}
			$("#" + id + "_content_wrapper").append("<div class='dki-element-overlay'></div><div " + titleString + " id='content_" + id + "' class='" + el.data("cssclass") + "' style='" + styleString + "' " + mouseOver + mouseOut + "></div>");
		},

		renderShapes: function(element){
			var fillColour = element.getAttribute("data-fillcolour") === "null" ? null : element.getAttribute("data-fillcolour");
			var gradient = element.getAttribute("data-fillgradient") === "null" ? null : element.getAttribute("data-fillgradient");
			var rolloverString;
			var rolloverFill;
			var opacity = 1;
			var rolloverOpacity = 1;
			var strokeColour =element.getAttribute("data-lineColour");
			rolloverFill = element.getAttribute("data-rollovercolour") == null || element.getAttribute("data-rollovercolour") == "none"? element.getAttribute("data-fillcolour"):element.getAttribute("data-rollovercolour");
			var rolloverGradient = element.getAttribute("data-rollovergradient") == null || element.getAttribute("data-rollovergradient") == "null"? element.getAttribute("data-fillgradient"):element.getAttribute("data-rollovergradient");
			var rolloverStroke = element.getAttribute("data-strokerollover") == null || element.getAttribute("data-strokerollover") == "none"?element.getAttribute("data-linecolour"):element.getAttribute("data-strokerollover");
			var shape = {};
			var borderThickness = element.getAttribute("data-linethickness");
			var width = parseInt(element.getAttribute("data-width")) - borderThickness;
			var height = parseInt(element.getAttribute("data-height"))  - borderThickness;
			var shapeType = element.getAttribute("data-shapeType").split(":");
			var paper = Raphael(element.childNodes[0],0,0, "100%", "100%");
			paper.canvas.style.height = element.getAttribute("data-height") + "px";
			paper.canvas.style.width = element.getAttribute("data-width") +"px";
			
			if(element.getAttribute("data-shapetype") == "hline" && parseInt(element.getAttribute("data-linethickness")) < 10){
				var thick = parseInt(element.getAttribute("data-linethickness"));
				paper.canvas.style.top = -(10-thick) +"px";	
			}
			paper.width = element.getAttribute("data-height");
			paper.height =  element.getAttribute("data-width");

			if (gradient === "transparent" || fillColour === null){
					gradient = fillColour;
					opacity = 0;
			}	
			if(element.getAttribute("data-filltype") == "1"){
				fillColour = element.getAttribute("data-colourAngle") + "-" + element.getAttribute("data-fillcolour") + "-" + gradient + ":" + element.getAttribute("data-stopPoint");
			}
			else if(element.getAttribute("data-filltype") == "2"){
				fillColour = "r(" + element.getAttribute("data-radialx") + "," + element.getAttribute("data-radialy") + ")" + element.getAttribute("data-fillcolour") + ":" +element.getAttribute("data-stopPoint") + "-" + gradient;
			}
			
			fillColour = fillColour == "transparent"? "": fillColour;

			if (rolloverGradient === "transparent" || rolloverFill === null){
					rolloverGradient = rolloverFill;
					rolloverOpacity = 0;
			}	
			if (element.getAttribute("data-filltype") == "0")
			{
				rolloverString = rolloverFill;
			}	
			else if(element.getAttribute("data-filltype") == "1"){
				rolloverString = element.getAttribute("data-colourAngle") + "-" + rolloverFill + ":" + element.getAttribute("data-stopPoint") + "-" +rolloverGradient;
			}
			else if(element.getAttribute("data-filltype") == "2"){
				rolloverString = "r(" + element.getAttribute("data-radialx") + "," + element.getAttribute("data-radialy") + ")" + rolloverFill + ":" + element.getAttribute("data-stopPoint")+ "-" + rolloverGradient;
			}
			rolloverString = rolloverString == "transparent"? "": rolloverString;
			var strokeColour = element.getAttribute("data-lineColour") == "transparent"? "" : element.getAttribute("data-lineColour");
			var cfg = {
				'fill': fillColour,
				'stroke':strokeColour,
				'stroke-width' : borderThickness,
				'stroke-dasharray': element.getAttribute("data-borderType"),
				'fill-opacity' : opacity
			}
			
			
			switch(shapeType[0]){
				case "rect":
					cfg["r"] = element.getAttribute("data-roundedCorners") == "true" ? 15:0;
					shape = paper.rect(borderThickness/2, borderThickness/2, width, height);
				break;
				case "circle":
					shape = paper.circle((height/2)+borderThickness/2,(height/2)+borderThickness/2, (height/2));
				break;				
				case "ellipse":
					shape = paper.ellipse((width/2) + (borderThickness/2),(height/2) + (borderThickness/2),width/2, height/2);
				break;
				case "vline":
					var x = parseInt(borderThickness);
					shape = paper.path("M" + x/2 + ",0 L" + x/2 + "," + (height+x));
				break;
				case "hline":
					var y = parseInt(borderThickness);
					shape = paper.path("M0," + y/2 +" L" + (width+y) + "," + y/2);
				break;
			}
			shape.attr(cfg);
			
			if (element.getAttribute("data-rollover") == "true") {
				$(element).mouseover(function(event){
					shape.attr({
						"fill": rolloverString,
						"stroke": rolloverStroke,
						"fill-opacity" : rolloverOpacity
					});
				});
				$(element).mouseout(function(event){
					shape.attr({
						"fill": fillColour,
						"stroke": strokeColour,
						"fill-opacity" : opacity
					});
				});
			}
		},

		canRenderShapes: function (){
			if(dkiUA.android){
				return dkiUA.androidVersion > 2.3;
			}
			else if(dkiUA.blackberry){
				return dkiUA.blackberryVersion > 6;
			}
			else if (dkiUA.webOS) {
				return false;
			}
			else{
				return true;
			}
		}
	};

	var component = function (cfg) {			
		this.mediaPlayers = {};
		this.autoPlayMedia = [];
		this.actions = null;
		this.actionHandlers = {};
		this.page = cfg.page;
		this.rootURL = cfg.player.rootURL;
		this.settings = cfg.player.settings;
		this.mediaCount = 0;
		this.readyMediaCount = 0;
		this.readyFired = false;
		this.objectTags = [];
		
		if (typeof(cfg.containerEl) == "string") {
			this.pageContainer = document.getElementById(cfg.containerEl);
		}
		else {
			this.pageContainer = cfg.containerEl;
		}
		if (!contentAPI) {
			contentAPI = cfg.contentAPI;
		}
		mediaFunctions.handleMedia(this);
		shapeFunctions.init(this);
		actionFunctions.init(cfg.actions, this, this.settings.clickEvent);
		//store the src of the iframes
		$(".dki-authoring-element iframe", this.pageContainer).each(function(){
			$(this).attr("data-src", this.src);
			this.src="about:blank";
		});
		//attach a handler for glossaries
		$(".dki-glossary-link", this.pageContainer).on("click", DKI.glossary.showPopup);
		$(".dki-glossary-link", this.pageContainer).hover(function(e) {
			DKI.glossary.showDefinition(e,this);
		}, function(e) {
			DKI.glossary.hideDefinition(e,this);
		});
		var self = this;
		//Detach & store any object tags
		if (!dkiUA.ie || dkiUA.ieVersion > 8) {
			$(".dki-videoembed-element object, .dki-chart-element object, .dki-flash-element object", this.pageContainer).each(function() {
				var storeage = {
					parentNode: this.parentNode,
					objTag: $(this).detach()
				};
				self.objectTags.push(storeage);
			});
		}
		if(this.settings.scrolling){
			$(this.pageContainer).on(DKI.ContentPage.events.shown, function(){
				self.resize();
			});
			$(this.pageContainer).on(DKI.ContentPage.events.hidden, function(){
				self.resize();
			});
		}
		//If not a mobile browser, fire page ready immediately
		if (!dkiUA.mobile) {
			this.fireReady();
		}
	};

	component.prototype.setAudio = function (audio) {
		contentFunctions.setAudio(audio, this);
	};
	component.prototype.pauseAll = function (){
		contentFunctions.pauseAll(this);
	};
	component.prototype.resumeAll = function () {
		contentFunctions.resumeAll(this);
	};
	component.prototype.resize = function(){		
		//case 29410 - calculate the height of the content.
		var scrollHeight = this.settings.courseHeight;
		$(".dki-authoring-element", this.pageContainer).each(function(){
			if ($(this).css("display") != "none") {
				var el = $(this);
				var bottom = parseInt(el.css("top").split("px")[0], 10) + el.height();
				if (bottom > scrollHeight) {
					scrollHeight = bottom;
				}
			}
		});
		$(document).trigger(DKI.ContentPage.events.resize, scrollHeight);
	};
	component.prototype.start = function () {
		this.resize();
		contentFunctions.startAutoPlay(this);		
		actionFunctions.startTimeouts(this);
		//set the src of the iframes
		$(".dki-authoring-element iframe", this.pageContainer).each(function(){
			this.src = $(this).attr("data-src");
		});
		//Loop through detached object tags & re-attach
		for (var i = 0; i < this.objectTags.length; i += 1) {
			this.objectTags[i].objTag.appendTo(this.objectTags[i].parentNode);
		}
	};
	component.prototype.reset = function () {
		var elementWrappers = $(".dki-authoring-element", this.pageContainer);
		$(this.pageContainer).trigger(DKI.ContentPage.events.reset);
		actionFunctions.reset(this);		
		contentFunctions.stopAll(this);
		elementWrappers.each(function () {
			if ($(this).data("renderhidden")) {
				$(this).css("display", "none");
			}
			else {
				$(this).css("display", "");
			}
			$(this).css("left", $(this).data("x") + "px");
			$(this).css("top", $(this).data("y") + "px");
		});
		//using this to reset any iframes (html widgets/video embeds) that might still be playing after going to the next page.
		$(".dki-authoring-element iframe", this.pageContainer).each(function(){
			this.src = "about:blank";
		});
		//Remove & re-add any <object> tags
		if (!dkiUA.ie || dkiUA.ieVersion > 8) {
			$(".dki-videoembed-element object, .dki-chart-element object, .dki-flash-element object", this.pageContainer).each(function () {
				var object = $(this).detach();
			});
		}
		//Fire ready event
		this.readyFired = false;
		this.fireReady();
	};
	component.prototype.isPaused = contentFunctions.isPaused;
	component.prototype.fireReady = function () {
		if (!this.readyFired) {
			this.readyFired = true;
			$(document).trigger(DKI.ContentPage.events.ready, this.page);
		}
	};

	return component;
	
})();
DKI.ContentPage.events = {
	resize: "PAGE_RESIZE",
	shown: "ELEMENT_SHOWN",
	hidden: "ELEMENT_HIDDEN",
	reset: "PAGE_RESET",
	ready: "PAGE_READY"
};

//below included for imageMaps
function showElement(ids, showEffect){
	if(!showEffect) showEffect = "show";
	var idArray = ids.split(",");
	for (var i = 0; i < idArray.length; i++) {
		var id = idArray[i];		
		var o = $("#" + id + "_wrapper");
		var callback = function () {			
			var contentID = "content_" + $(this).data("id");
			var content = $("#" + contentID);
			//Callback will be fired once for each element shown/hidden.  As it's a jQuery callback,
			//'this' will be the element being shown/hidden
			$(this).trigger(DKI.ContentPage.events.shown, this);
			if (content.data("autoplay")) {
				var bindFunction;						
				content.jPlayer("play");
				bindFunction = function (e) {									
					content.jPlayer("play");
					content.unbind(e);
				};
				$(content).bind($.jPlayer.event.ready, bindFunction);					     
			}
		};
		if (showEffect != "show") {
			o.show(showEffect, {}, 800, callback);
			
		}
		else {
			o.show(0, callback);
			
		}
	}
}

function hideElement(ids, hideEffect){
	if(!hideEffect) hideEffect = "hide";
	var idArray = ids.split(",");
	for (var i = 0; i < idArray.length; i++) {
		var id = idArray[i];
		var o = $("#" + id + "_wrapper");
		var callback = function () {			
			var contentID = "content_" + $(this).data("id");
			var content = $("#" + contentID);
			//Callback will be fired once for each element shown/hidden.  As it's a jQuery callback,
			//'this' will be the element being shown/hidden
			$(this).trigger(DKI.ContentPage.events.hidden, this);			
			if (o.data("type") == "audio" || o.data("type") == "video") {
				content.jPlayer("pause");
			}
		};		
		if (hideEffect != "hide") {
			o.hide(hideEffect, {}, 800, callback);
		}
		else{
			o.hide(0, callback);
		}			
	}
}

function showHideElement(ids, showEffect, hideEffect){
	 if(ids == null || ids == undefined || ids == '') 
	   return;
	var idArray = ids.split(",");
	for (var i = 0; i < idArray.length; i++) {
		var id = idArray[i];
		if (document.getElementById(id + "_wrapper").style.display == "none") {
			showElement(id, showEffect);
		}
		else{
			hideElement(id, hideEffect);
		}
	}
}
function processHrefTarget(hrefTarget, hideTargetOnLoad){	
	//trying/catching because of some weird bug collision with swfobject.. dont have time to deal with it now.
	//the problem is in splitting a string that doesnt have commas.. it should return a 1 length array but instead it tthreows an error in swf object.
	try {
		var hrefTarget = hrefTarget.toString();
		var targetIdArray = hrefTarget.split(",");
		for (var i = 0; i < targetIdArray.length; i++) {
			var targetId = targetIdArray[i];
			$("#" + targetId + "_wrapper").addClass("dki-event-target");
			$("#" + targetId + "_wrapper").addClass("dki-imagemap-target");
			$("#" + targetId + "_wrapper").data("eventtargets", hrefTarget);		
		}
	}
	catch(e){
		var targetId = hrefTarget;
		$("#" + targetId + "_wrapper").addClass("dki-event-target");
		$("#" + targetId + "_wrapper").addClass("dki-imagemap-target");
		$("#" + targetId + "_wrapper").data("eventtargets", hrefTarget);
	}	
}

function hideAllEventElements(){
	$(".dki-event-target").hide();
}

function processHttpEvent(el){	
	var url = $(el).data("href");
	var hrefWindow = window.open(url, 'hrefWindow', '');
}	
