var dkiUA = (function () {
	var webOS = false;
	var iOS = false;
	var iOSVersion = 0;
	var android = false;
	var androidVersion;
	var blackberry = false;
	var blackberryVersion = 0;
	var winPhone = false;
	var webKit = false;
	var windows = false;
	var safari = false;
	var safariVersion = 0;
	var mobile = false;
	var ie = false;
	var ieVersion = 0;
	var firefox = false;
	var firefoxVersion = 0;
	//The 'native' player from OnPoint.  Requires content workarounds, so it's important to note
	var cellCast = false;
	var cellCastSearch = /CellCast/i;
	var webOSSearch = /webOS/i;
	var iOSSearch = /iphone|ipad|ipod/i;
	var iOSVersionSearch = /OS (\d\_?\d)/i;
	var blackberrySearch = /BlackBerry/i;
	var blackberryVersionSearch = /Version\/(\d\.?\d)/i;
	var androidSearch = /Android/i;
	var androidVersionSearch = /Android (\d\.?\d)/i;
	var androidVersionSearchCellCast = /Android[\/|\d|\.]* *\((\d+\.*\d+)/i;
	var winPhoneSearch = /Windows Phone OS/i;
	var webKitSearch = /WebKit/i;
	var windowsSearch = /Windows/i;
	var sarariSearch = /Safari/i;
	var chromeSearch = /Chrome/i;
	var safariVersionSearch = /Version\/([0-9]+)/;
	var ieSearch = /Internet Explorer|ie|IE/i;
	var ieVersionSearch = /MSIE ([0-9]+)/;
	var firefoxSearch = /Firefox/i;
	var firefoxVersionSearch = /Firefox\/([0-9]+)/;
	if (cellCastSearch.test(navigator.userAgent)) {
		cellCast = true;
		mobile = true;
	}
	if (webOSSearch.test(navigator.userAgent)) {
		webOS = true;
		webKit = true;
		mobile = true;
	}
	else if (iOSSearch.test(navigator.userAgent)) {
		iOS = true;
		iOSVersion = parseFloat(iOSVersionSearch.exec(navigator.userAgent)[1]);
		webKit = true;
		mobile = true;
	}
	else if (blackberrySearch.test(navigator.userAgent)) {
		blackberry = true;
		if(blackberryVersionSearch.test(navigator.userAgent)){
			blackberryVersion = parseFloat(blackberryVersionSearch.exec(navigator.userAgent)[1]);
		}
		mobile = true;
	}
	else if (androidSearch.test(navigator.userAgent)) {
		android = true;
		if (!cellCast) {
			androidVersion = parseFloat(androidVersionSearch.exec(navigator.userAgent)[1]);
		}
		else {
			androidVersion = parseFloat(androidVersionSearchCellCast.exec(navigator.userAgent)[1]);
		}
		mobile = true;
	}
	else if (winPhoneSearch.test(navigator.userAgent)) {
		winPhone = true;
		mobile = true;
	}

	if(windowsSearch.test(navigator.userAgent)){
		windows = true;
	}

	if(sarariSearch.test(navigator.userAgent) && !chromeSearch.test(navigator.userAgent) && !android){
		safari = true;
		if (safariVersionSearch.test(navigator.userAgent)) {
			safariVersion = parseInt(safariVersionSearch.exec(navigator.userAgent)[1]);
		}
	}

	if(ieSearch.test(navigator.userAgent)){
		ie = true;
		if (ieVersionSearch.test(navigator.userAgent)) {
			ieVersion = parseInt(ieVersionSearch.exec(navigator.userAgent)[1]);
		}
	}

	if (webKitSearch.test(navigator.userAgent)) {
		webKit = true;
	}

	if (firefoxSearch.test(navigator.userAgent)) {
		firefox = true;
		if (firefoxVersionSearch.test(navigator.userAgent)) {
			firefoxVersion = parseInt(firefoxVersionSearch.exec(navigator.userAgent)[1]);
		}
	}

	return {
		webOS: webOS,
		iOS: iOS,
		iOSVersion: iOSVersion,
		blackberry: blackberry,
		blackberryVersion: blackberryVersion,
		android: android,
		androidVersion: androidVersion,
		winPhone: winPhone,
		windows: windows,
		safari: safari,
		safariVersion: safariVersion,
		ie: ie,
		ieVersion: ieVersion,
		firefox: firefox,
		firefoxVersion: firefoxVersion,
		mobile: mobile,
		webKit: webKit
	}
})();
