var DKI;
if (!DKI) {DKI = {};}
DKI.EndModule = function () {
	var player;
	var testOnly;
	var dataStorage;
	var behaviour;
	var currentModule; 
	var moduleProgress;
	var moduleScore;
	var strings;
	var state;
	var assessment;
	var testingLink;

	var init = function (playerObj) {
		player = playerObj;
		dataStorage = player.dataStorage;
		testOnly = player.course.testOnly == "1" ? true : false;
		behaviour = player.behaviour;
		strings = playerObj.strings;
		if (player.inAssessment || player.inReview) {
			assessment = dataStorage.assessment;
			state = dataStorage.assessment.prepost;
			currentModule = assessment.module;
		}
		else {
			state = "content";
			currentModule = dataStorage.currentModule;
			assessment = null;
		}
		$(document).trigger(DKI.EndModule.events.ready);
	}

	var start = function () {
		var pageContainer = player.pageFrames.current;
		var modulePassingScore = currentModule.passMark ? currentModule.passMark : player.course.passMark;
		var passStatus;
		var passStatusClass;
		var moduleScoreDetails;
		var statusContainer = $(".status", pageContainer);
		var endContainer = $(".endScreen", pageContainer).addClass(state);
		var revisitLink = $(".endMod_revisitLink", pageContainer);
		var reviewLink = $(".endMod_reviewLink", pageContainer);

		testingLink = $(".endMod_testingLink", pageContainer);
		reviewLink.css("display", "none");
		revisitLink.click(function () {
			player.jumpToModule(currentModule);
		});
		if (assessment) {
			reviewLink.click(function () {
				player.launchReview(assessment);
			});
		}
		moduleProgress = dataStorage.getModuleCompletion(currentModule);
		if (state === "content") {
			moduleScoreDetails = dataStorage.getModuleScoringDetails(currentModule);
		}
		else {
			moduleScoreDetails = {
				score: assessment.getScore(),
				points: assessment.getPoints(),
				weight: assessment.getWeight()
			};
		}
		if (!dataStorage.moduleHasTest(currentModule)) {
			testingLink.css("display", "none");			
		}
		else if (dataStorage.remainingPostAttempts(currentModule) > 0 && state !== "pre") {
			testingLink.removeClass("disabled");
			if (currentModule.post && currentModule.post.attempts > 0) {
				//Test has already been attempted
				testingLink.text(strings.retakeTest);
				if (assessment) {
					reviewLink.css("display", "block");
				}
			}
			testingLink.click(function () {
				player.launchTest(currentModule.id, "post");
			});
		}
		
		$("#endMod_moduleName", pageContainer).text(currentModule.name);

		$(".endMod_learningLink", pageContainer).click(function () {
			player.resume((state === "pre"));
		});
		if (testOnly) {
			$("#endMod_learningLine", pageContainer).css("display", "none");
			revisitLink.css("display", "none");
		}
		else {
			$("#endMod_learningStatus", pageContainer).text(moduleProgress + "%");
		}

		if (!isNaN(parseInt(moduleScoreDetails.score, "10"))) {
			$("#endMod_testScore", pageContainer).text(moduleScoreDetails.score + "%" + 
				" (" + moduleScoreDetails.points + "/" + moduleScoreDetails.weight + " " + strings.txtPoints + ")");
			if (behaviour.displayPass && behaviour.passModules && moduleScoreDetails.weight > 0) {
				passStatus = moduleScoreDetails.score >= modulePassingScore ? strings.passText : strings.failText;
				passStatusClass = moduleScoreDetails.score >= modulePassingScore ? "pass" : "fail";
				statusContainer.addClass("showPassing");
				$(".endMod_passingScore", pageContainer).text(modulePassingScore + "%");
				$(".endMod_passStatus", pageContainer).text(" - " + passStatus + " - ").addClass(passStatusClass);
				$("#endMod_testScore", pageContainer).removeClass("dki-themeTextColor").addClass(passStatusClass);
			}
		}
		else {
			$("#endMod_testScore", pageContainer).text(strings.txtNotAvailableShort);
			$("#endMod_scoreLine", pageContainer).hide();
			$("#endMod_learningLine", pageContainer).addClass("dki-lineitem-last");
		}
	}

	return {
		init: init,
		start: start
	}
}();

DKI.EndModule.events = {
	ready: "END_MODULE_READY"
};
