DKI.glossaryBrowse = function() {
	var mobile = $("body").hasClass("phone"),
		searchMarkup = "<div id='searchContainer'>" +
						"<div id='searchIcon'/>" +
						"<input id='searchBox' type='text'></input>" +
					"</div>",

		browserMarkup = "<div id='glossaryBrowserContainer' class='loading'>"+
			"<div id='browserHeader'>" +
				"<span id='glossaryBrowserTitle' class='browserTitle'></span>" +
				"<div id='glossaryBrowserClose' class='browserCloseButton'></div>"+
			"</div>";
			
		if(mobile) {
			browserMarkup +="<div id='back'> Back </div>" ;
			browserMarkup += searchMarkup;
		}

		browserMarkup +=
			"<div id='glossaryContentContainer'>" +
				"<div id='termList' class='panel'>";
		if(!mobile) {
			browserMarkup += searchMarkup;
		}
					
					
		browserMarkup +="<ul class='terms'></ul>" +
				"</div>" +
				"<div id='termDetails' class='panel'>" +
					"<div class='detailsContent'>" +
						"<div>" +
							"<div id='term'></div>" +
							'<div id="glossaryManagePronunciation" class="jp-basic">' +					
								"<div class=\"jp-type-single\">" +
									"<div id=\"glossaryManagePronunciation_player\" class=\"jp-audio\"></div>" +
									"<div class=\"jp-gui jp-basic jp-interface\">" +
										"<div class=\"jp-controls-holder\">" +
											"<ul class=\"jp-controls\">" +
												"<li><a class=\"jp-play\" tabindex=\"0\" role=\"button\">play</a></li>" +
												"<li><a class=\"jp-pause\" tabindex=\"0\" role=\"button\">pause</a></li>" +
											"</ul>" +
										"</div>" +
									"</div>" +
								"</div>" +
						"</div>" +
						'</div><div class="sectionBreak"></div>' +
						"<div id='definition'></div><div class='sectionBreak'></div>" +
						"<div id='attribution'></div>" +
					"</div>" +
				"</div>" +
			"</div>" +
		"</div>";
		var browser = {},
		terms = [],
		

		initialize = function(config) {
			terms = config.terms;
			settings = config.settings;
			language = config.languageStrings;
			pronunciationPlayer = {};
			$("#contentFrame").append(browserMarkup);
			$("#glossaryBrowserTitle").html(language.titleText);
			browser.container = $("#glossaryBrowserContainer");
			browser.contentContainer = $("#glossaryContentContainer");
			browser.player = $("#glossaryManagePronunciation");
			browser.close = $("#glossaryBrowserClose");
			browser.back = $("#back");
			browser.termList = {
				container 		: $("#termList"),
				termElements	: []
			},
			browser.termDetails = {
				termTitle :  $("#term"),
				termDefinition : $("#definition"),
				attribution : $("#attribution")
			};
			populateTermList(terms);
			$("#searchBox").jsonSearch({
				"data" :terms, 
				"searchKey" :'term',
				onSelect : function(term) {
					selectTerm(term.id);
				}
			});
			$("#glossaryBrowserContainer #glossaryManagePronunciation_player").jPlayer({
				swfPath: settings.swfPath,
				cssSelectorAncestor: "#glossaryManagePronunciation",
				ready: function(){
					pronunciationPlayer = $(this);
					$("#termDetails .detailsContent").hide();
					browser.container.css("display", "none");
					browser.container.css("visibility", "visible");	
					browser.container.removeClass('loading');
					// Player Events
					contentApi.playerEvent.on('pageLoaded',function(){browser.container.hide()});
					if(typeof player !== 'undefined') {
						player.navigation.forwardButton.on(settings.clickEvent,function(){hide();});
					}	
				},
				supplied: "mp3",
				autohide: false,
				loop: false,
				preload: "auto",
				solution: "flash,html",
				size: {
					width: 0 + "px",
					height: 0 + "px"
				},
				muted: false,
				volume: 1
			});	
			browser.close.on(settings.clickEvent, function(){
				hide();
			});
			if(mobile) {
				browser.back.on(settings.clickEvent,function(){browser.back.fadeOut(200);shiftContainer(0)});
			}
			browser.container.draggable({handle : $("#browserHeader"), containment : ".dkiContentFrame.current"});
		},
		show = function() {
			browser.container.show();
			if(mobile) {
				shiftContainer(-273);
				browser.back.fadeIn(200);
			}
			if(typeof player != 'undefined') {
				player.navigation.setGlossaryState(true);
			}
		},
		hide = function() {
			pronunciationPlayer.jPlayer("stop");
			browser.container.hide();
			if(typeof player != 'undefined') {
				player.navigation.setGlossaryState(false);
			}
		},
		populateTermList = function(terms) {
			$.each(terms, function(index,term) {
				var element = $("<li/>", {
					"id" : term.id,
					"html" :  term.term
				});
				element.on(settings.clickEvent, function(){
					termClicked(term.id);
				});
				browser.termList.container.append(element);
				browser.termList.termElements.push(element);
			});
		},

		getTerm = function(termId) {
			for(var i = 0; i < terms.length; i++){			
				if(terms[i].id == termId){
					return terms[i];
				}
			}
		},
		termClicked = function(id) {
			pronunciationPlayer.jPlayer("stop");
			selectTerm(id);
			if(mobile){
				shiftContainer(-273);
			}
		},
		shiftContainer = function(left){
			browser.contentContainer.animate({
					left : left
				}, 300);
		},
		getTerms = function() {
			return terms;
		},
		selectTerm = function(termId) {
			show();
			$("#termDetails .detailsContent").show();
			var term = getTerm(termId);
			setTermHighlight(termId);
			browser.termDetails.termTitle.html(term.term);
			browser.termDetails.termDefinition.html(term.definition);
			browser.termDetails.attribution.html("Source: " + term.attribution);
			if(term.pronunciation_asset_filename){
				browser.player.show();
				pronunciationPlayer.jPlayer("setMedia", {
					"mp3": settings.assetURL + term.pronunciation_asset_filename
				});
			}
			else{
				browser.player.hide();
			}
		},
		setTermHighlight = function(termId) {
			$("#termList li").removeClass("selected");
			$("#" + termId).addClass("selected");
		},
		isEmpty = function() {
			return terms.length > 0 ? false : true;
		}

		return {
			getTerms 	: getTerms,
			initialize 	: initialize,
			show 		: show,
			hide 		: hide,
			selectTerm  : selectTerm,
			isEmpty 	: isEmpty
		};
}();