DKI.Marker = {
	scoreQuestion: function (question, choices) {
		var score = 0;
		if (question.type == "1") {
			score = this.scoreTrueFalse(choices, question.options);
		}
		else if (question.type == "2") {
			score = this.scoreMultipleChoice(choices, question.options);
		}
		else if (question.type == "3") {
			score = this.scoreFreeForm(choices, question.options);
		}
		else if (question.type == "4") {
			score = this.scoreFillBlanks(choices, question.options);
		}
		else if (question.type == "5") {
			score = this.scoreMultiplePulldown(choices, question.options);
		}
		else if (question.type == "6") {
			score = this.scoreDragDrop(choices, question.options);
		}
		else{
			throw("Invalid question type: "  + question.type);
		}	

		return isNaN(score) ? 0 : score;
	},
	scoreTrueFalse: function (choices, options) {
		if (options[0].correct && choices[0] == 1) {
			return 100;
		}
		else if (options[1].correct && choices[1] == 1) {
			return 100;
		}
		else {
			return 0;
		}
	},
	scoreMultipleChoice: function (choices, options) {
		var totalScore = 0;
		var correctChoices = 0;
		var incorrectChoices = 0;
		for (var i = 0; i < options.length; i ++) {
			if (options[i].correct) {
				totalScore ++;
				if (choices[i] && choices[i].checked == 1) {
					correctChoices ++;
				}
			}
			else if (choices[i] && choices[i].checked == 1) {
				incorrectChoices ++;
			}
		}
		correctChoices -= incorrectChoices;
		if (correctChoices > 0) {
			return Math.round(correctChoices / totalScore * 100);
		}
		else {
			return 0;
		}
	},
	scoreFillBlanks: function (choices, options) {
		var acceptedAnswers;
		var correctAnswers = 0;
		var totalAnswers = 0;
		for (var i = 0; i < options.length; i ++){
			totalAnswers ++;
			acceptedAnswers = options[i].correctValues;
			for (var j = 0; j < acceptedAnswers.length; j ++) {
				if ($.trim(acceptedAnswers[j].toString().toLowerCase()) === $.trim(choices[i].toString().toLowerCase())) {
					correctAnswers ++;
					break;
				}
			}
		}
		return Math.round(correctAnswers / totalAnswers * 100);
	},
	scoreMultiplePulldown: function (choices, options) {
		var correctChoices = 0;
		var totalAnswers = 0;
		var correctAnswer;
		for (var i = 0; i < options.length; i ++) {			
			totalAnswers ++;	
			correctAnswer = options[i].correctValue;
			if (choices[i].toString().toLowerCase() === correctAnswer.toString().toLowerCase()) {
				correctChoices ++;
			}			
		}

		return Math.round(correctChoices / totalAnswers * 100); 
	},
	scoreFreeForm: function () {
		return 0; 
	},
	scoreDragDrop: function(choices, options){
		if(choices.length == 0 && options.length == 0){
			return 0;
		}
		var correctChoices = 0;
		var totalAnswers = options.length;
		var correct = false;
		var option = null;
		for (var i = 0; i < choices.length; i ++) {
			correct = false;
			option = null;
			for (var k = 0; k < options.length; k++) {
				if(options[k].element_id == choices[i].elementId){
					option = options[k];
					break;
				}
			}
			for(var k = 0; k < option.correctTargets.length; k++){
				if(choices[i].target.id == option.correctTargets[k]){
					correct = true;
				}
			}
			if(!choices[i].target.id && option.correctTargets.length == 0){
				correct = true;
			}
			if (correct) {
				correctChoices ++;
			}			
		}
		return Math.round(correctChoices / totalAnswers * 100); 
	}
};
