var DKI;
if (!DKI) {
	DKI = {};
}
DKI.TestQuestion = function () {
	//Determine if this is a single page preview.  If so, question will be self-scoring.
	var isSinglePage = $(document.body).data("singlepage") ? true : false;
	var isMobile = (screen.availWidth <= 480) || ($(document.body).width() <= 480) || (dkiUA.android);
	var Private = {
		closeFeedback: function (e) {
			e.stopPropagation();
			this.feedbackWrapper.addClass("hidden");
			return false;
		},
		submit: function (event) {			
			var options = this.getOptions();
			var i = 0;
			event.preventDefault();
			event.stopPropagation();
			if (Private.overMaxOptions.call(this)) {
				alert(this.strings.tstchoicesLabel1 + " " + this.maxSelections + " " + this.strings.tstchoicesLabel2);
				return false;
			}
			this.submitButton.unbind(event);
			if (!isSinglePage) {
				//This call is here to force correct/incorrect to be marked during full course preview.  Don't have time for a cleaner solution
				//Private.scorePreview.call(this);
				Private.scoreExport.call(this);
			}
			else {
				this.setScore(Private.scorePreview.call(this));
			}
			return false;
		},
		overMaxOptions: function () {
			var tooManyChoices = false;
			var checkedCount = 0;
			
			if (this.questionType == 2 || this.questionType == 3) {
				var options = this.getOptions();	
				for (var i = 0; i < options.length; i ++) {
					if (options[i].value().checked == 1) {
						checkedCount ++;
					}
				}
				if (checkedCount > this.maxSelections) {
					tooManyChoices = true;
				}
			}

			return tooManyChoices;
		},
		atMaxOptions: function () {
			var atMax = false;
			var checkedCount = 0;
			
			if (this.questionType == 2 || this.questionType == 3) {
				var options = this.getOptions();	
				for (var i = 0; i < options.length; i ++) {
					if (options[i].value().checked == 1) {
						checkedCount ++;
					}
				}
				if (checkedCount == this.maxSelections) {
					atMax = true;
				}
			}

			return atMax;
		},
		positionSubmitButton: function(){
			var top = 0;
			var elementBottom = 0;
			var pageHeight = $(this.pageContainer).height() + $("#headerContainer").height();
			var left = 0;
			this.submitButton.text(this.strings.buttonLabelSubmit);
			//if there is no "bottom" defined, define it the one time.
			//This is to solve case 27904.. apparently as you adjust top, Firefox will retro in bottom.
			if(typeof this.submitButton.data("bottom") === 'undefined'){
				this.submitButton.data("bottom", parseInt(this.submitButton.css("bottom").split("px")[0]));				
			}
			//find the bottom most element	
			$(".dki-authoring-element", this.pageContainer).each(function(){
				var el = $(this);
				var bottom = parseInt(el.css("top").split("px")[0], 10) + el.height();
				if(bottom > elementBottom){
					elementBottom = bottom;
				}
			});
			elementBottom += this.submitButton.height() + this.submitButton.data("bottom");			
			if(elementBottom > pageHeight && !$(document.body).hasClass('online')){								
				if ($(document.body).hasClass('phone')) {
					//add the height of the submit button to the page so it has a spot thats not cutting off elements and not not being cut off by the page				
					var newHeight = $(this.pageContainer).height() + this.submitButton.height() + this.submitButton.data("bottom");
					$(this.pageContainer).height(newHeight);
					this.player.contentFrame.height(newHeight);
				}	
				top = elementBottom - this.submitButton.height() - this.submitButton.data("bottom");
			}
			else{
				top = pageHeight - this.submitButton.height() - this.submitButton.data("bottom");
			}			
			if ($(document.body).hasClass('phone')) {
				this.submitButton.width(($(this.pageContainer).width() * 0.9));
				this.scoreDisplay.width(($(this.pageContainer).width() * 0.9));
				left = ($(this.pageContainer).width() * 0.05) + "px";
			}
			else {
				left = "";
			}
			this.submitButton.css({
				position: "absolute",
				left: left,
				top: top + "px",
				right: "",
				margin: 0
			});
			this.scoreDisplay.css({
				position: "absolute",
				left: left,
				top: top + "px",
				right: "",
				margin: 0
			});		
			if (this.preview || !this.inReview) {
				this.submitButton.fadeIn(200);	
				this.submitButton.bind(this.player.settings.clickEvent, $.proxy(Private.submit, this));	
			}
		},	
		positionFeedback: function() {
			var container = $(document.body).data("singlepage")? this.pageContainer : window;
			this.feedbackWrapper.css({
				top: parseInt(($(container).height() - this.feedbackWrapper.height()) / 2, 10) + $(document.body).scrollTop() + "px"
			});
		},
		scorePreview: function () {
			var options = this.getOptions();
			var fullScore = this.getCorrectCount();
			var correctChoices = 0;
			var incorrectChoices = 0;
			var optionScore = 0;
			var score = 0
			var optionValues = [];

			for (var i = 0; i < options.length; i ++) {
				optionScore = options[i].score();
				if (optionScore === 1) {
					correctChoices ++;
				}
				else if (optionScore === -1) {
					incorrectChoices ++;
				}
				optionValues[i] = options[i].value();
				if (Private.showCorrectAnswers.call(this)) {
					options[i].showCorrect();
				}
			}
			score = this.calculate(fullScore, correctChoices, incorrectChoices);
			//Get all element wrappers for options marked correct, incorrect or multiChoiceCorrectResponse, and float to the top 
			$(".dki-authoring-element", this.pageContainer).has(".correct, .incorrect, .multiChoiceCorrect").css("zIndex", 100000);

			return score;
		},
		scoreExport: function () {
			var options = this.getOptions();
			var body = $(".questionBody", this.pageContainer);
			var submitObject = {
				type: this.questionType,
				body: body.text(),
				latency: new Date().getTime() - this.startTime,
				options: []
			};
			for (var i = 0; i < options.length; i ++) {
				submitObject.options[i] = options[i].value();
			}
			$(document).trigger(DKI.TestQuestion.events.submitted, submitObject);
		},
		showCorrectFeedback: function () {
			return Private.doShowFeedback.call(this, this.correctFeedback);
		},
		showIncorrectFeedback: function () {			
			return Private.doShowFeedback.call(this, this.incorrectFeedback);
		},
		showPartialFeedback: function () {
			return Private.doShowFeedback.call(this, this.partialFeedback);
		},
		doShowFeedback: function (feedbackElement) {
			var self = this;
			var showFeedback = function () {	
				self.feedbackWrapper.removeClass("hidden");
				feedbackElement.css("display", "block");			
			}
			if (Private.showFeedback.call(this) && feedbackElement.length > 0) {
				if (this.inReview) {
					setTimeout(showFeedback, 500);
				}
				else {
					showFeedback();
				}				
				return true;
			}
			else if(!self.inReview) {
				if ($(document.body).hasClass('mobile')) {										
					this.player.contentFrame.height($(this.pageContainer).height() - this.submitButton.height());
				}	
				$(document).trigger(DKI.TestQuestion.events.nextClicked);
			}
			return false;
		},
		showFeedback: function() {
			if (!this.behaviour || this.preview) {
				return true;
			}
			else if (!this.inReview && this.behaviour.displayQuestionFeedback) {
				return true;
			}
			else if (this.inReview) {
				if (this.prePost == "pre" && this.behaviour.reviewPreFeedback) {
					return true;
				}
				else if (this.prePost == "post" && this.behaviour.reviewPostFeedback) {
					return true;
				}
				else {
					return false;
				}
			}
			else {
				return false;
			}
		},
		showCorrectAnswers: function () {
			if (!this.behaviour || this.preview) {
				return true;
			}
			else if (this.inReview) {
				if (this.prePost == "pre" && this.behaviour.reviewPreAnswers) {
					return true;
				}
				else if (this.prePost == "post" && this.behaviour.reviewPostAnswers) {
					return true;
				}
				else {
					return false;
				}
			}
			else {
				//If behaviour is defined and we are not in a review, this is a recorded assessment.  We do not want to show the correct answers.
				return false;
			}
		}
	};
	var Public = {
		setPrePost: function (prePost) {
			if (prePost) {
				this.prePost = prePost;
			}
			else {
				this.prePost = "post";
			}
		},
		setScore: function (score, points, weight) {
			if (score !== undefined && score !== null) {
				score = parseFloat(score, 10);
			}
			//Workaround for a bug in jQuery 1.6.1.  When a custom event is fired and the data payload is the integer 0, data becomes undefined.
			else {
				score = 0;
			}
			var that = this;
			var feedbackShown = false;
			if (score <= 0) {
				feedbackShown = Private.showIncorrectFeedback.call(this);
			}
			else if (score === 100) {
				feedbackShown = Private.showCorrectFeedback.call(this);
			}
			else {
				feedbackShown = Private.showPartialFeedback.call(this);
			}			
			if (this.inReview) {
				$(".questionScore").text(points + "/" + weight + " " + this.strings.txtPoints);
				this.scoreDisplay.fadeIn(200);
			}
			else if(feedbackShown){				
				this.submitButton.text(this.strings.buttonLabelNext);
				this.submitButton.bind(this.player.settings.clickEvent, $.proxy(function (e) {
					this.submitButton.unbind(e);
					this.submitButton.hide();
					if ($(document.body).hasClass('mobile')) {										
						this.player.contentFrame.height($(this.pageContainer).height() - this.submitButton.height());
					}			
					e.preventDefault();
					e.stopPropagation();
					$(document).trigger(DKI.TestQuestion.events.nextClicked);
				}, this));
			}
		},
		setOptions: function (userChoices, questionOptions) {
			var options = this.getOptions(); 
			for (var i = 0; i < options.length; i ++) {
				options[i].value(userChoices[i]);
				options[i].enabled(false);
				options[i].correctResponse(questionOptions[i]);
			}
		},
		showReview: function (prePost, userChoices, questionOptions, question) {
			this.inReview = true;
			this.setPrePost(prePost);
			this.setOptions(userChoices, questionOptions);
			//Call to highlight correct/incorrect
			Private.scorePreview.call(this);
			this.setScore(question.score, question.points, question.weight);	
		},
		start: function () {			
			this.page.start();			
			Private.positionSubmitButton.call(this);
			//set up D&D
			if(this.questionType == 6){
				$(".dki-authoring-element[data-draggable=true]", this.pageContainer).draggable({
					revert: function (event, ui) {						
			            $(this).data("draggable").originalPosition = {
			                top: $(this).data("y"),
			                left: $(this).data("x")
			            };
			            return !event;
			        },
					start: function(event, ui){
						var dragTitle = $(this).data("title");
						if(dragTitle == ""){
							dragTitle = $(this).text();
						}
						$(this).data("dropData", {
							id: $(this).data("dragdropid"),
							elementId: $(this).data("id"),
							title:  dragTitle,
							target: {
								id: null,
								title: "No Target"
							},
							x: $(this).data("x"),
							y: $(this).data("y")
						});
					},
					stack: ".dkiContentFrame.current .dki-authoring-element[data-droppable=true]"
					
				});
				$(".dki-authoring-element[data-droppable=true]", this.pageContainer).droppable({
					accept: ".dkiContentFrame.current .dki-authoring-element[data-draggable=true]",
					tolerance: "pointer",	
					drop: function(event, ui){
						var dragTitle =ui.draggable.data("title");
						if(dragTitle == ""){
							dragTitle = ui.draggable.text();
						}
						var dropTitle = $(this).data("title");
						if(dropTitle == ""){
							dropTitle = $(this).text();
						}
						var position = ui.draggable.position();
						ui.draggable.data("dropData", {
							id: ui.draggable.data("dragdropid"),
							elementId: ui.draggable.data("id"),
							title: dragTitle,
							target: {
								id: $(this).data("dragdropid"),
								title: dropTitle
							},
							x: position.left,
							y: position.top
						});
					}
				});
			}							
		},
		reset: function () {			
			this.page.reset();
			if(this.questionType == 6){
				$(".dki-authoring-element[data-draggable=true]", this.pageContainer).draggable("option", "disabled", true);
				$(".dki-authoring-element[data-droppable=true]", this.pageContainer).droppable("option", "disabled", true);
			}
							
		}
	};
	var component = function (playerObj, contentPage, question) {
		//This function will apply the 'checked' CSS class to a given input's label, based on it's 'checked' status
		var checkInput = function (input) {
			var label = $("label[for='" + input.attr("id") + "']", contentPage.pageContainer);
			//For radio inputs, need to remove 'checked' class for all inputs
			$(".content input[type='radio']", contentPage.pageContainer).each(function (index, element) {
				$("label[for='" + element.id + "']").removeClass("checked");
			});
			if (input.prop("checked")) {
				label.addClass("checked");
			}
			else {
				label.removeClass("checked");
			}
		};
		this.question = question;
		this.player = playerObj;			
		this.strings = playerObj.strings;
		this.page = contentPage;
		this.behaviour = this.player.behaviour;
		this.inReview = this.player.inReview;
		this.prePost = "";
		this.pageContainer = this.page.pageContainer;
		this.questionElement = $("div[data-pagetype='question']", this.pageContainer);
		this.questionType = parseInt(this.questionElement.attr("data-questiontype"), 10);
		this.startTime = new Date().getTime();
		this.submitButton = $(".submitButton");		
		this.scoreDisplay = $(".questionScoreDisplay");
		this.feedbackWrapper = $(".feedbackWrapper", this.pageContainer);
		this.correctFeedback = $(".correctFeedback", this.pageContainer);
		this.incorrectFeedback = $(".incorrectFeedback", this.pageContainer);
		this.partialFeedback = $(".partialFeedback", this.pageContainer);					
		this.maxSelections = parseInt(this.questionElement.attr("data-max-selections"), 10);
		this.freeFormMaxLength = 4000;
		//if were using scorm 1.2, the maximum is 255.
		if (typeof scormAPI !== 'undefined' && scormAPI.strLMSStandard == "SCORM") {
			this.freeFormMaxLength = 255;
		}
		$(".feedbackClose", this.pageContainer).bind(this.player.settings.clickEvent, $.proxy(Private.closeFeedback, this));	
		switch (this.questionType) {
			case 1:
				this.getCorrectCount = $.proxy(DKI.TestQuestion.TrueFalseQuestion.getCorrectCount, this);
				this.getOptions = $.proxy(DKI.TestQuestion.TrueFalseQuestion.getOptions, this);
				this.scoreOption = $.proxy(DKI.TestQuestion.TrueFalseQuestion.scoreOption, this);
				this.calculate = $.proxy(DKI.TestQuestion.TrueFalseQuestion.calculate, this);				
				$(".trueOption_label", this.pageContainer).text(this.strings.trueOptionLabel);
				$(".falseOption_label", this.pageContainer).text(this.strings.falseOptionLabel);
				break;
			case 2:
				this.getCorrectCount = $.proxy(DKI.TestQuestion.MultipleChoiceQuestion.getCorrectCount, this);
				this.getOptions = $.proxy(DKI.TestQuestion.MultipleChoiceQuestion.getOptions, this);
				this.scoreOption = $.proxy(DKI.TestQuestion.MultipleChoiceQuestion.scoreOption, this);
				this.calculate = $.proxy(DKI.TestQuestion.MultipleChoiceQuestion.calculate, this);
				break;
			case 3:
				this.getCorrectCount = $.proxy(DKI.TestQuestion.FreeFormQuestion.getCorrectCount, this);
				this.getOptions = $.proxy(DKI.TestQuestion.FreeFormQuestion.getOptions, this);
				this.scoreOption = $.proxy(DKI.TestQuestion.FreeFormQuestion.scoreOption, this);
				this.calculate = $.proxy(DKI.TestQuestion.FreeFormQuestion.calculate, this);
				break;
			case 4:
				this.getCorrectCount = $.proxy(DKI.TestQuestion.FillBlanksQuestion.getCorrectCount, this);
				this.getOptions = $.proxy(DKI.TestQuestion.FillBlanksQuestion.getOptions, this);
				this.scoreOption = $.proxy(DKI.TestQuestion.FillBlanksQuestion.scoreOption, this);
				this.calculate = $.proxy(DKI.TestQuestion.FillBlanksQuestion.calculate, this);
				break;
			case 5:
				this.getCorrectCount = $.proxy(DKI.TestQuestion.MultiplePulldownQuestion.getCorrectCount, this);
				this.getOptions = $.proxy(DKI.TestQuestion.MultiplePulldownQuestion.getOptions, this);
				this.scoreOption = $.proxy(DKI.TestQuestion.MultiplePulldownQuestion.scoreOption, this);
				this.calculate = $.proxy(DKI.TestQuestion.MultiplePulldownQuestion.calculate, this);
				//Added below for case 28831 - we need to randomize the options each view, not just in the services			
				$(".dki-multiPulldownOption-element select", this.pageContainer).each(function(){
					var getRandomOptions = function(options){
						var randomOptions = options;
						var i = randomOptions.length;										
						while (i--){
							var j = Math.floor( Math.random() * ( i + 1 ) );
							var tempI = randomOptions[i];
							var tempJ = randomOptions[j];
							randomOptions[i] = tempJ;
							randomOptions[j] = tempI;
						}
						return randomOptions;
					}
					var newOptions = [];
					for(var i = this.options.length - 1; i >= 0; i--){
						if ($(this.options[i]).html() != "") {
							newOptions.push(this.options[i]);							
						}
						this.remove(i);
					}
					var newOptions = getRandomOptions(newOptions);
					this.innerHTML = "";
					
					if(dkiUA.ie && dkiUA.ieVersion <= 8){
						this.add(new Option("", ""));
						for(var i = 0; i < newOptions.length; i++){
							this.add(newOptions[i], i+1);
						}
					}
					else{
						this.add(new Option("", ""), null);
						for(var i = 0; i < newOptions.length; i++){
							this.add(newOptions[i], null);
						}
					}
					this.selectedIndex = 0;
				});
				break;
			case 6:
				this.getCorrectCount = $.proxy(DKI.TestQuestion.DragDropQuestion.getCorrectCount, this);
				this.getOptions = $.proxy(DKI.TestQuestion.DragDropQuestion.getOptions, this);
				this.scoreOption = $.proxy(DKI.TestQuestion.DragDropQuestion.scoreOption, this);
				this.calculate = $.proxy(DKI.TestQuestion.DragDropQuestion.calculate, this);				
				break;
		}

		this.player.questionPage = this;
		this.feedbackWrapper.draggable();
		
		// Creates a delegate that allows the whole question option element to be touched
		var that = this;
		$(this.pageContainer).on(
			"click", 
			".dki-multiChoiceOption-element input", 
			function(e){		
				var label = $("label[for='" + $(this).attr("id") + "']");		
				if(!label.hasClass("checked")){
					if (Private.overMaxOptions.call(that)) {
						 $(this).prop("checked", false);
						alert(that.strings.tstchoicesLabel1 + " " + that.maxSelections + " " + that.strings.tstchoicesLabel2);
						return false;
					}
				}													
						
			}
		);
		$(this.pageContainer).on(
			"click", 
			".dki-trueFalseOption-element, .dki-multiChoiceOption-element", 
			function(e){		
				var input = $("#content_" + $(this).data("id") + " input");															
				if (e.target.tagName !== "INPUT") {
					var label = $("label[for='" + input.attr("id") + "']");		
					if(!label.hasClass("checked")){
						if (Private.atMaxOptions.call(that) && input.attr("type") != "radio") {
							alert(that.strings.tstchoicesLabel1 + " " + that.maxSelections + " " + that.strings.tstchoicesLabel2);
							return false;
						}
					}
					if (!input.prop("checked")) {
						input.prop("checked", "true");
					}
					else if (input.attr("type") == "checkbox") {
						input.prop("checked", false);
					}
					checkInput(input);
					//gotta return false in here to prevent defaults for labels.
					return false;
				}				
				checkInput(input);				
			}
		);
		$(".dki-freeFormOption-element textarea").attr("maxlength", this.freeFormMaxLength);
		$(this.pageContainer).on(
			"keyup", 
			".dki-freeFormOption-element textarea", 
			function(e){
				var text = $(this).val();
				var chars = text.length;
				if (chars > that.freeFormMaxLength) {
					var newText = text.substr(0, that.freeFormMaxLength);  
					$(this).val(newText);
				}
			}
		);
	};

	DKI.applyIf(component.prototype, Public);

	return component;
}();

DKI.TestQuestion.events = {submitted: "TESTQUESTION_SUBMITTED", nextClicked: "TESTQUESTION_NEXT_CLICKED"};

DKI.TestQuestion.TrueFalseQuestion = {
	calculate: function (fullScore, correctOptions, incorrectOptions) {
		if (correctOptions < 1) {
			return 0;
		}
		
		return 100;
	},
	getCorrectCount: function () {
		return 1;
	},
	getOptions: function () {
		var optionArray = $("input[type='radio']", this.pageContainer);
		var returnArray = [];
		var order;
		for (var i = 0; i < optionArray.length; i++) {
			order = parseInt(optionArray[i].getAttribute("data-order"), "10") - 1;
			returnArray[order] = new DKI.TestQuestion.TrueFalseOption(optionArray[i]);	
		}
		return returnArray;
	}
};

DKI.TestQuestion.TrueFalseOption = function (option) {
	this.optionElement = option;

	this.correctResponse = function(questionOption) {
		if (questionOption != null && questionOption != undefined) {
			this.optionElement.setAttribute("data-correctresponse", questionOption.correct);
		}
		else {
			return this.optionElement.getAttribute("data-correctresponse");	
		}
	};

	this.enabled = function (enabled) {
		if (enabled !== undefined && enabled !== null) {
			this.optionElement.disabled = !enabled;
		}
		else {
			return !this.optionElement.disabled;
		}
	};

	this.value = function (value) {
		if (value !== undefined && value !== null) {
			if (value == true || value == 1) {
				this.optionElement.checked = true;
			}
			else {
				this.optionElement.checked = false;
			}
		}
		else {
			if (this.optionElement.checked) {
				return 1;
			}
			else {
				return 0;
			}
		}
	};

	this.score = function () {
		if (this.value() == 1 && this.correctResponse() == "true") {
			return this.value();
		}
		else {
			return 0;
		}
	};

	this.showCorrect = function () {
		if (this.value() == 1 && this.correctResponse() == "true") {
			$(this.optionElement.parentNode.parentNode).addClass("correct");		
		}
		else if (this.value() == 1) {
			$(this.optionElement.parentNode.parentNode).addClass("incorrect");
		}
		if (this.correctResponse() == "true") {
			$(this.optionElement.parentNode.parentNode).addClass("multiChoiceCorrectResponse");
		}
	};
};

DKI.TestQuestion.MultipleChoiceQuestion = {
	calculate: function (fullScore, correctOptions, incorrectOptions) {
		if (incorrectOptions > correctOptions) {
			return 0;
		}
		else {
			return (((correctOptions - incorrectOptions) / fullScore) * 100);
		}
	},
	getCorrectCount: function () {
		return $(".dki-multiChoiceOption-element input[data-correctresponse='true']", this.pageContainer).length;
	},
	getOptions: function () {
		var elementArray = $(".dki-multiChoiceOption-element input", this.pageContainer);
		var options = [];
		var order;
		for (var i = 0; i < elementArray.length; i++) {
			
			order = parseInt(elementArray[i].getAttribute("data-order"), "10") - 1;
			options[order] = new DKI.TestQuestion.MultipleChoiceOption(elementArray[i]);
		}
		return options;
	}
};

DKI.TestQuestion.MultipleChoiceOption = function (option) {
	this.optionElement = option;
	this.optionValue = $(option).next();

	this.correctResponse = function (questionOption) {
		if (questionOption != null && questionOption != undefined) {
			this.optionElement.setAttribute("data-correctresponse", questionOption.correct);
		}
		else {
			return this.optionElement.getAttribute("data-correctresponse");
		}
	};

	this.enabled = function (enabled) {
		if (enabled !== null && enabled !== undefined) {
			this.optionElement.disabled = !enabled;
		}
		else {
			return !this.optionElement.disabled;
		}
	};
	
	this.value = function (value) {
		if (value !== null && value !== undefined) {
			if (value.checked == 1) {
				this.optionElement.checked = true;
			}
			else {
				this.optionElement.checked = false;
			}
		}
		else {
			var valueObj = {text: this.optionValue.text()};
			if (this.optionElement.checked) {
				valueObj.checked = 1;
			}
			else {
				valueObj.checked = 0;
			}
			return valueObj;
		}
	};

	this.score = function () {
		if (this.value().checked == 1 && this.correctResponse() == "true") {
			return 1;
		}

		else if (this.value().checked == 1 && this.correctResponse() == "false") {
			return -1;
		}
		else {
			return 0;
		}
	};

	this.showCorrect = function () {
		if (this.value().checked == 1) {
			if (this.correctResponse() == "true") {
				$(this.optionElement.parentNode.parentNode).addClass("correct");
			}
			else {
				$(this.optionElement.parentNode.parentNode).addClass("incorrect");
			}
		}
		if (this.correctResponse() == "true") {
			$(this.optionElement.parentNode.parentNode).addClass("multiChoiceCorrectResponse");
		}
	};
}

DKI.TestQuestion.FillBlanksQuestion = {
	calculate: function (fullScore, correctOptions, incorrectOptions) {
		return((correctOptions / fullScore) * 100);
	},
	getCorrectCount: function () {
		return this.getOptions().length;
	},
	getOptions: function () {
		var elementArray = $("input[type='text']", this.pageContainer);
		var options = [];
		var order;
		for (var i = 0; i < elementArray.length; i++) {
			order = parseInt(elementArray[i].getAttribute("data-order"), "10") - 1;
			options[order] = new DKI.TestQuestion.FillBlanksOption(elementArray[i]);
		}
		return options;
	}
};

DKI.TestQuestion.FillBlanksOption = function (option) {
	this.optionElement = option;

	this.correctResponse = function (questionOption) {
		if (questionOption != null && questionOption != undefined) {
			this.optionElement.setAttribute("data-correctresponse", questionOption.correctValues);
		}
		else {
			return this.optionElement.getAttribute("data-correctresponse");
		}
	};

	this.enabled = function (enabled) {
		if (enabled !== null && enabled !== undefined) {
			this.optionElement.disabled = !enabled;
		}
		else {
			return !this.optionElement.disabled;
		}
	};
	
	this.value = function (value) {
		if (value !== null && value !== undefined) {
			$(this.optionElement).val(value);
		}
		else {
			return $(this.optionElement).val();
		}
	};

	this.score = function () {
		if (this.correctResponse() !== null) {
			var correctArray = this.correctResponse().split(",");
			for (var i = 0; i < correctArray.length; i ++) {
				if ($.trim(this.value().toLowerCase()) === $.trim(correctArray[i].toLowerCase())) {
					return 1;
				}
			}
		}
		return 0;
	};

	this.showCorrect = function () {
		if (this.score() == 1) {
			$(this.optionElement.parentNode.parentNode).addClass("correct");
		}
		else {
			$(this.optionElement.parentNode.parentNode).addClass("incorrect");
		}
	};
};

DKI.TestQuestion.MultiplePulldownQuestion = {
	calculate: function (fullScore, correctOptions, incorrectOptions) {
		return ((correctOptions / fullScore) * 100);
	},
	getCorrectCount: function () {
		return this.getOptions().length;
	},
	getOptions: function () {
		var elementArray = $("select", this.pageContainer);
		var options = [];
		var order
		for (var i = 0; i < elementArray.length; i++) {
			order = parseInt(elementArray[i].getAttribute("data-order"), "10") - 1;
			options[order] = new DKI.TestQuestion.MultiplePulldownOption(elementArray[i]);
		}
		return options;
	}
};

DKI.TestQuestion.MultiplePulldownOption = function (option) {
	this.optionElement = option;

	this.correctResponse = function (questionOption) {
		if (questionOption != null && questionOption != undefined) {
			this.optionElement.setAttribute("data-correctresponse", questionOption.correctValue);
		}
		else {
			return this.optionElement.getAttribute("data-correctresponse");
		}
	};

	this.enabled = function (enabled) {
		if (enabled !== null && enabled !== undefined) {
			this.optionElement.disabled = !enabled;
		}
		else {
			return !this.optionElement.disabled;
		}
	};

	this.value = function (value) {
		if (value !== null && value != undefined) {
			$(this.optionElement).val(value);
		}
		else {
			return $(this.optionElement).val();
		}
	};

	this.score = function () {
		if (this.value() === this.correctResponse()) {
			return 1;
		}
		else {
			return 0;
		}
	};

	this.showCorrect = function () {
		if (this.score() == 1) {
			$(this.optionElement.parentNode.parentNode).addClass("correct");
		}
		else {
			$(this.optionElement.parentNode.parentNode).addClass("incorrect");
		}
	};
};

DKI.TestQuestion.FreeFormQuestion = {
	calculate: function () {
		return 0;
	},
	getCorrectCount: function () {
		return 0;
	},
	getOptions: function () {
		var elementArray = $(".dki-freeFormOption-element textarea", this.pageContainer);
		var options = [];
		var order;
		for (var i = 0; i < elementArray.length; i++) {
			order = parseInt(elementArray[i].getAttribute("data-order"), "10") - 1;
			options[order] = new DKI.TestQuestion.FreeFormOption(elementArray[i]);
		}
		return options;
	}
};

DKI.TestQuestion.FreeFormOption = function (option) {
	this.optionElement = option;

	this.correctResponse = function () {
		return "";
	};

	this.enabled = function (enabled) {
		if (enabled !== null && enabled !== undefined) {
			this.optionElement.disabled = !enabled;
		}
		else {
			return !this.optionElement.disabled;
		}
	};
	
	this.value = function (value) {
		if (value !== null && value !== undefined) {
			$(this.optionElement).val(value);
		}
		else {
			return $(this.optionElement).val();
		}
	};

	this.score = function () {		
		return 0;
	};

	this.showCorrect = function () {
		if (this.value() != "") {
			$(this.optionElement.parentNode.parentNode).addClass("correct");
		}
		else {
			$(this.optionElement.parentNode.parentNode).addClass("incorrect");
		}
	};
};

DKI.TestQuestion.DragDropQuestion = {
	calculate: function (fullScore, correctOptions, incorrectOptions) {
		if(fullScore == 0 && correctOptions == 0 && incorrectOptions == 0){
			return 0;
		}
		return ((correctOptions / fullScore) * 100);
	},
	getCorrectCount: function () {
		return $(".dki-authoring-element[data-draggable=true]", this.pageContainer).length;
	},
	getOptions: function () {
		var elementArray = $(".dki-authoring-element[data-draggable=true]", this.pageContainer);
		var options = [];
		var order;
		for (var i = 0; i < elementArray.length; i++) {	
			var option = null;
			var elementId = $(elementArray[i]).data("id");
			for(var k = 0; k < this.question.options.length; k++){
				if(this.question.options[k].element_id == elementId){
					option = this.question.options[k];
				}
			}
			options[i] = new DKI.TestQuestion.DragDropOption(elementArray[i], option);
		}
		return options;
	}
};

DKI.TestQuestion.DragDropOption = function (optionElement, questionOption) {
	this.optionElement = optionElement;
	this.questionOption = questionOption;

	this.correctResponse = function (questionOption) {
		var dropData = this.value();
		$(this.optionElement).css({
			"top": dropData.y + "px",
			"left": dropData.x + "px"
		});
		return null;
	};

	this.enabled = function (enabled) {
		if (enabled !== null && enabled !== undefined) {			
			$(this.optionElement).draggable({
				disabled: !enabled
			});
			var highestTargetZIndex = 0;
			$(".dki-authoring-element[data-droppable=true]", this.pageContainer).each(function(){
				var zIndex = parseInt($(this).css("z-index"), 10);
				if(zIndex > highestTargetZIndex){
					highestTargetZIndex = zIndex;
				}
			});
			$(this.optionElement).css("z-index", highestTargetZIndex + 1);
		}
		else {
			return false;
		}
	};
	
	this.value = function (value) {
		if (value !== null && value !== undefined) {
			$(this.optionElement).data("dropData", value);
		}
		else {
			var dropData = $(this.optionElement).data("dropData");
			if(!dropData){
				var position = $(this.optionElement).position();
				var title = $(this.optionElement).data("title");
				if(title == ""){
					title = $(this.optionElement).text();
				}		
				dropData = {
					id: $(this.optionElement).data("dragdropid"),
					elementId: $(this.optionElement).data("id"),
					title: title,
					target: {
						id: null,
						title: "No Target"
					},
					x: position.left,
					y: position.top
				};
			}
			return dropData;
		}
	};

	this.score = function () {
		var dropData = this.value();		
		var currentDropTarget = dropData.target.id;
		if (currentDropTarget) {
			for(var i = 0; i < this.questionOption.correctTargets.length; i++){
				if(currentDropTarget == this.questionOption.correctTargets[i]){
					return 1;
				}
			}
			return -1;
		}
		else if (this.questionOption.correctTargets.length > 0) {
			return -1;
		}
		else {
			return 1;
		}		
	};

	this.showCorrect = function () {
		if (this.score() == 1) {
			$(this.optionElement).addClass("correct");
		}
		else {
			$(this.optionElement).addClass("incorrect");
		}
	};
};

