var DKI;
if (!DKI) {
	DKI = {};
}

/**
 * Copies the properties from the fromObject to the toObject and returns the toObject
 * @extends	DKI
 * @method	apply
 * @param	toObject 	required the object to modify
 * @param	fromObject	required the object to copy into toObject
 * @return	toObject
 */
DKI.apply = function(toObject, fromObject){
	for(prop in fromObject){
		toObject[prop]=fromObject[prop]
	}
	return toObject;
}; //-> end apply


/**
 * Copies the properties from the fromObject to the toObject IF the toObject does not contain them and returns the toObject
 * @extends	DKI
 * @method	apply
 * @param	toObject 	required the object to modify
 * @param	fromObject	required the object to copy into toObject
 * @return	toObject
 */
DKI.applyIf = function(toObject,fromObject){
	for(prop in fromObject){
		if(toObject[prop]==undefined){
			toObject[prop]=fromObject[prop]
		}
	}
	return toObject;
}; //-> end applyIf

DKI.determineRoot = function () {
	var currentURL = window.location.href;
	var dirOnly = /\/$/;
	if (dirOnly.test(currentURL)) {
		return currentURL
	}
	else {
		return currentURL.replace(/\?.*$/, "").replace(/\w*\.[a-zA-Z]+$/, "");
	}
};

DKI.stripHTML =  function(htmlString) {
	htmlString = htmlString.toString();
	htmlString = htmlString.replace(/<(?:.|\s)*?>/g, "");
	htmlString = htmlString.replace(/\&nbsp\;/g, " ");
	htmlString = htmlString.replace(/\s+/g, " ");	
	return htmlString;   
};
